# -*- coding: ISO_8859-1 -*-
#-----------------------------------------------------------------------------------------------------
print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
from netmiko import ConnectHandler # netmiko: modulo che gestisce la connessione via SSH 
from sys import exit
import os
import platform
import subprocess
import time
#-----------------------------------------------------------------------------------------------------
print("---------------------------------------------------------------------------------------------------\n")
print("Programma in Python 3.x per il caricamento via SSH da un server TFTP della startup-config su degli apparati Cisco,")
print("leggendone indirizzi IP, username e password da un file.")
print("Il file deve avere il seguente formato (va usato come separatore uno spazio):")
print("la prima riga deve contenere l'indirizzo IP del server TFTP")
print("le altre righe del file contengono <Indirizzo IP> <username> <password> di ciascun apparato \n")
print("esempio di file: \n")
print("10.0.0.150")
print("10.0.0.248 studente telecom")
print("10.0.0.200 userpippo passwordpippo \n")
print("---------------------------------------------------------------------------------------------------")
print(" Programma realizzato da Onelio Bertazioli")
print("---------------------------------------------------------------------------------------------------\n")
#--------------------------------------------------------------------------------------------------------
sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
#
#funzione che esegue un ping sull'indirizzo IP passato come parametro
def ping(indip):
    if sist_operativo == "Windows":
       pinga = subprocess.call("ping -n 2 -w 500 " + indip)  # fai due richieste di echo (la prima pu fallire) con timeout di 500 ms
    else:
       pinga = os.system("ping -c 2 " + indip)      # con Ubuntu funziona questo
    return pinga
#---------------------------------------------------------------------------------------------------
esci = "n"
while esci != "s": #FINO A QUANDO esci  diverso da "s" continua a ripetere il ciclo 
 #determina data e ora da inserire nel report del nome del file
 orario = time.strftime("%H:%M")
 oranome = time.strftime("%H_%M")
 data = time.strftime("%d-%m-%Y")
 print ("data_" + str(data) + "_ora_" + str(orario))
#--------------------------------------------------------------------------------------------------------
# apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
 salvareport = open("Report_aggiornamento_startup-config_data_" + str(data) + "_ora_" + str(oranome) + "_.txt", "w")
 salvareport.write("---------------------------------------------------------------------------------------------------\n")
 salvareport.write("Programma in Python 3.6 per il caricamento via SSH da un server TFTP della startup-config di apparati Cisco,\n")
 salvareport.write("leggendone indirizzi IP, username e password da un file. \n")
 salvareport.write("--------------------------------------------------------------------------------------------------- \n")
 salvareport.write(" Programma realizzato da Onelio Bertazioli " + "\n")
 salvareport.write("---------------------------------------------------------------------------------------------------\n")
 salvareport.write("Data: " + str(data) + " Ora: " + str(orario)) #scrivi nel file la data e l'ora del backup
 salvareport.write("---------------------------------------------------------------------------------------------------\n")

 fileok = "n"
 while fileok != "s": # se il nome del file digitato  errato o il file non esiste 
     print ("  n--> si usa il file di default; ")
     print ("  s --> fornire il nome del file e l'eventuale percorso (se non  nella stessa directory dello script)) \n")
     sceltafile = input("Vuoi fornire un nuovo file con gli indirizzi IP, username e password? [s/n] ")
     print ("")
     print("-" *120 + "\n")
     if sceltafile == "s":
        nomefile = input("Percorso e nome del file con gli indirizzi IP, username e password: ")
        print ("")
     else:
        nomefile = "fileipuserpw.csv" #nome di default del file da aprire
     #la prima riga del file contiene l'indirizzo IP del server TFTP
     try:
         file = open(nomefile)      #apri il file e mettine il contenuto nella variabile file
         fileok = "s" 
     except IOError:
         print ("+" *100 + "\n")
         print ("    Attenzione! Il file " + nomefile + " non esiste! \n")
         salvareport.write("Attenzione! Il file " + nomefile + " non esiste! \n")
         
         print ("+" *100 + "\n")
         riprova = input("Vuoi riprovare [s/n]? ")
         print ("\n")
         print ("+" *100 + "\n")
         if riprova == "n":
             fine = input(" Premere Invio per uscire dal programma!")
             salvareport.close()
             exit()
         elif riprova == "N":
             salvareport.close()
             fine = input(" Premere Invio per terminare il programma!")
             exit()

#
#-------------- Inizia leggendo i dati contenuti nel file: ind. IP server TFTP, ecc.-----------------------------------
#la prima riga del file contiene l'indirizzo IP del server TFTP
 try:
     file = open(nomefile)      #apri il file e mettine il contenuto nella variabile file
 except FileNotFoundError:
        print ("Il file non esiste!")
        exit()
        
 indip = file.readline()    # leggi la prima riga del file, che contiene l'indirizzo IP DEL SERVERTFTP
 servertftp = indip.strip() #metti nella varibile servertftp l'indirizzo IP del server TFTP; con strip() si elimina il <cr> finale che manda a capo
 #
 print ("Nome del file: " + nomefile)
 print ("Server TFTP: " + servertftp)
 print("---------------------------------------------------------------------------------------------------\n")
 #salva nel report
 salvareport.write("Nome del file: " + nomefile + "\n")
 salvareport.write("Server TFTP: " + servertftp + "\n")
 salvareport.write("---------------------------------------------------------------------------------------------------\n")
 #
 # VERIFICA CON UN PING CHE IL SERVER TFTP SIA RAGGIUNGIBILE
 esitoping = ping(servertftp)
 if esitoping == 0:                                 # SE IL PING HA SUCCESSO RESTITUISCE 0
    print ("--------------------------------------------------------------------------------------------------- \n")
    print ("         Il server TFTP " + servertftp + "  funzionante! \n")
    print ("--------------------------------------------------------------------------------------------------- \n")
    salvareport.write("Il server TFTP " + servertftp + "  funzionante! \n")
 else:
    print ("---------------------------------------------------------------------------------------------------\n")
    print ("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE!\n")
    print ("IMPOSSIBILE EFFETTUARE L'AGGIORNAMENTO! IL PROGRAMMA VIENE TERMINATO!\n")
    print ("---------------------------------------------------------------------------------------------------\n")
    salvareport.write("-----------------------------------------------------------------------\n")
    salvareport.write("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE! \n")
    salvareport.write("IMPOSSIBILE EFFETTUARE L'AGGIORNAMENTO! IL PROGRAMMA VIENE TERMINATO! \n")
    salvareport.write("-----------------------------------------------------------------------\n")
    uscita = input("Premere <invio> per continuare! ")
    esci = "s"
    break
#--------------------------------------------------
# leggi indirizzo IP, username e password degli apparati (A PARTIRE DALLA SECONDA RIGA)
 #
 for riga in file:             
     if riga !=(" "): 
       parole = riga.split()    #split() separa le singole parole contenute nella riga e le mette in una lista
       HOST = parole[0]         #la prima parola  l'indirizzo IP dell'host (l'apparato di rete)
       user = parole[1]         # la seconda parola  lo username
       password = parole[2]     # la terza parola  la password
       #print (HOST, user, password)
     else:
       break   
#-----------------------------------------------------------------------------------
     # esegui comandi ping diversi a seconda che la piattaforma sia Windows o LINUX
     esitoping = ping(HOST)
     if esitoping == 0:                                # l'host ha risposto al ping
         print ("--------------------------------------------------------------------------------------------------- \n")
         print ("                             L'host " + HOST + " risponde \n")
         print ("                                      Attendere!       \n") 
         #
         salvareport.write("--------------------------------------------------------------------------\n")
         salvareport.write("            L'host " + HOST + " risponde!                \n")
         salvareport.write("--------------------------------------------------------------------------\n")
         #  apri una connessione SSH con l'host e inviagli il comando per copiare la startup-config dal server tftp nella running-config
         connessione_SSH = ConnectHandler(device_type='cisco_ios', ip = HOST, username = user, password = password)  #apre la connessione SSH
         # invia i comandi
         prompt = connessione_SSH.find_prompt(10) #acquisisci il prompt dei comandi aumentando il timeout a 20 (default 1)
         hostname = prompt.strip("#")           # togli dal prompt il # finale per avere solo l'hostname 
         #
         print (" L'host " + hostname + " sta cercando di caricare la nuova running-config dal server TFTP " + servertftp +"\n")
         #
         # prepara il comando da dare per caricare la startup-config dal server TFTP
         comando =  "copy tftp://" + servertftp + "/" + (hostname) + "-confg running-config \n"
         #    
         risposta = connessione_SSH.send_command_timing(comando,2) #invia il comando e accetta il nome proposto con timeout 2 (default 1)
         leggirisposta = connessione_SSH.send_command_timing("\n",2) # manda un invio e salva la risposta dell'host
         #print (" comando: -->" + comando)
         #print (" Risposta: -->" + risposta)
         #
         print ("--------------------------------------------------------------------------------------------------- \n")
         print ("Messaggi scambiati dall'host " + hostname + " col server TFTP: " + servertftp + " \n" )
         print (leggirisposta)
         salvareport.write("--------------------------------------------------------------------------\n")
         salvareport.write("Messaggi scambiati dall'host " + HOST + " col server TFTP: \n")
         salvareport.write(leggirisposta + "\n")
         print ("--------------------------------------------------------------------------------------------------- \n")
         #
         #------------------- verifica se nei messaggi scambiati c' una indicazione di errore nel caricamento del file
         #
         for cercaerrore in leggirisposta.split(): #separa con split() le singole parole contenute nella risposta e cerca i messaggi di errore
             #print ("------cercaerrore------> " + cercaerrore)
             if cercaerrore == "%Error":
               print ("--------------------------------------------------------------------------------------------------- ")
               print ("ATTENZIONE! Non  stato possibile caricare il file di configurazione dal server TFTP \n  ")
               print ("---------------------------------------------------------------------------------------------------\n")
               salvareport.write("\n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("ATTENZIONE! Non  stato possibile caricare il file di configurazione dal server TFTP! \n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               break
             elif cercaerrore == "Loading":  #non ci sono errori il trasferimento  stato completato
               #
               print (" Attendere! L'host sta salvando la running-config nella startup-config e sul server TFTP! \n")
               connessione_SSH.write_channel("\n") #manda un invio 
               comando = "copy running-config startup-config"
               risposta = connessione_SSH.send_command_timing(comando) #invia il comando, accetta il nome proposto e salva la risposta
              
               #print (" Risposta: -->" + risposta)
               connessione_SSH.write_channel("\n") #manda un invio per ottenere il protmpt dei comandi con l'eventuale nuovo nome host
                #
               comando = ("copy startup-config tftp://" + servertftp)
               #print ("Comando -------> " + comando)
               risposta = connessione_SSH.send_command_timing(comando) #invia il comando e accetta l'indirizzo IP proposto
               connessione_SSH.write_channel("\n") 
               #print (" Risposta: -->" + risposta)
               
               prompt = connessione_SSH.find_prompt(50) #acquisisci il prompt dei comandi aumentando il timeout a 50,
               hostname = prompt.strip("#") #acquisisci nuovamente il nomehost che potrebbe essere cambiato
               #print (" hostname -->" + hostname + " \n")
               print (" Hostname con la nuova running-config: " + hostname + " \n")
               #fino a quando non si  raggiunta la fine del file e si ha esci = s
               print ("--------------------------------------------------------------------------------------")
               print (" Running-config dell'host " + hostname + " IP " + HOST + " correttamente aggiornata!  ")
               print (" Configurazione salvata nella startup-config!                                        ")
               print (" Startup-config salvata anche nel server TFTP!                                        ")     
               print ("--------------------------------------------------------------------------------------\n")
               #
               salvareport.write("\n")
               salvareport.write("-------------------------------------------------------------------------------------- \n")
               salvareport.write("Running-config dell'host " + hostname + " IP " + HOST + " correttamente aggiornata! \n")
               salvareport.write("Startup-config correttamente aggiornata! \n")
               salvareport.write("Startup-config salvata anche nel server TFTP! \n")
               salvareport.write("\n")
               salvareport.write("-------------------------------------------------------------------------------------- \n")
               salvareport.write("\n")
               break
     else:   # se il ping fallisce viene restituito un numero >0
         print ("---------------------------------------------------------------------------------------------------\n")
         print ("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         print ("---------------------------------------------------------------------------------------------------\n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
         salvareport.write("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
#
 uscita = input("Vuoi uscire [s/n]: ")
 print ("---------------------------------------------------------------------------------------------------\n")
 #
 esci = uscita[0]  #considera solo il primo carattere digitato
 esci = esci.lower()
 #if esci == "S":   #trasforma l'eventuale maiuscola in minuscola
  #  esci = "s"
salvareport.close() #chiudi il file del report
print ("Grazie per aver usato il programma!")
