#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
import telnetlib
from sys import exit
import sys
import os
import platform
import subprocess
import time
#-----------------------------------------------------------------------------------------------------
print("-------------------------------------------------------------\n")
print("Script Python 3.x per il backup su un server TFTP della startup-config di apparati Cisco,")
print("leggendone indirizzi IP, username e password da un file.")
print("Il file deve avere il seguente formato (va usato come separatore uno spazio):")
print("la prima riga deve contenere l'indirizzo IP del server TFTP")
print("le altre righe del file contengono <Indirizzo IP> <username> <password> di ciascun apparato \n")
print("esempio di file: \n")
print("10.0.0.150 ")
print("10.0.0.248 itis majorana ")
print("10.0.0.200 userpippo passwordpippo \n")
print("-------------------------------------------------------------")
print(" Programma realizzato da Onelio Bertazioli")
print("-------------------------------------------------------------\n")
#--------------------------------------------------------------------------------------------------------
#
sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
#print ("Sistema operativo: " + sist_operativo) --> decommentare se si vuole visualizzare a video il tipo di s.o.
#---------------------------------------------------------------------------------------------------
esci = "n"
while esci != "s": #FINO A QUANDO esci è diverso da "s" continua a ripetere il ciclo 
 print("-------------------------------------------------------------\n")
 print ("  n--> si usa il file di default; ")
 print ("  s --> fornire il nome del file e l'eventuale percorso (se non è nella stessa directory dello script)) \n")
 sceltafile = input("Vuoi fornire un nuovo file con gli indirizzi IP, username e password? [s/n] ")
 print("-------------------------------------------------------------\n")
 if sceltafile == "s":
    nomefile = input("Percorso e nome del file con gli indirizzi IP, username e password: ")
 else:
    nomefile = "fileipuserpw.csv" #nome di default del file da aprire
 print("-------------------------------------------------------------\n")
#determina data e ora da inserire nel report del nome del file
 orario = time.strftime("%H:%M")
 oranome = time.strftime("%H_%M")
 data = time.strftime("%d-%m-%Y")
 print ("data_" + str(data) + "_ora_" + str(orario))
#--------------------------------------------------------------------------------------------------------
# apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
 salvareport = open("Report_backup_data_" + str(data) + "_ora_" + str(oranome) + "_.txt", "w")
 salvareport.write("-------------------------------------------------------------\n")
 salvareport.write("Script Python 2.7 per il backup su un server TFTP della startup-config di apparati Cisco,\n")
 salvareport.write("leggendone indirizzi IP, username e password da un file. \n")
 salvareport.write("------------------------------------------------------------- \n")
 salvareport.write(" Script realizzato da Onelio Bertazioli " + "\n")
 salvareport.write("-------------------------------------------------------------\n")
 salvareport.write("Data: " + str(data) + " Ora: " + str(orario)) #scrivi nel file la data e l'ora del backup
 salvareport.write("\n")
#
#-------------- Inizia leggendo i dati contenuti nel file: ind. IP server TFTP, ecc.-----------------------------------
#la prima riga del file contiene l'indirizzo IP del server TFTP
 file = open(nomefile)      #apri il file e mettine il contenuto nella variabile file
 indip = file.readline()    # leggi la prima riga del file, che contiene l'indirizzo IP DEL SERVERTFTP
 servertftp = indip.strip() #metti nella varibile servertftp l'indirizzo IP del server TFTP; con strip() si elimina il <cr> finale che manda a capo
 #
 print ("Nome del file: " + nomefile)
 print ("Server TFTP: " + servertftp)
 print("-------------------------------------------------------------\n")
 #salva nel report
 salvareport.write("Nome del file: " + nomefile + "\n")
 salvareport.write("Server TFTP: " + servertftp + "\n")
 salvareport.write("-------------------------------\n")
 #
 # VERIFICA CON UN PING CHE IL SERVER TFTP SIA RAGGIUNGIBILE
 if sist_operativo == "Windows":
    pinga = subprocess.call("ping -n 2 -w 500 " + servertftp)
 else:
    pinga = os.system("ping -c 2 " + servertftp)       # con Ubuntu funziona questo
    #pinga = subprocess.call("ping -c 1 " + servertftp)
    #print (pinga)
 if pinga == 0:                                 # SE IL PING HA SUCCESSO RESTITUISCE 0
    print ("Il server TFTP " + servertftp + " è funzionante! \n")
    salvareport.write("Il server TFTP " + servertftp + " è funzionante! \n")
 else:
    print ("-------------------------------------------------------------------------\n")
    print ("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE!\n")
    print ("IMPOSSIBILE EFFETTUARE IL BACKUP! LO SCRIPT VIENE TERMINATO!\n")
    print ("-------------------------------------------------------------------------\n")
    salvareport.write("-----------------------------------------------------------------------\n")
    salvareport.write("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE! \n")
    salvareport.write("IMPOSSIBILE EFFETTUARE IL BACKUP! LO SCRIPT VIENE TERMINATO! \n")
    salvareport.write("-----------------------------------------------------------------------\n")
    uscita = input("Premere <invio> per continuare! ")
    esci = "s"
    exit()
    
#--------------------------------------------------
# leggi indirizzo IP, username e password degli apparati (A PARTIRE DALLA SECONDA RIGA)
 #
 for riga in file:             
     parole = riga.split()    #split() separa le singole parole contenute nella riga e le mette in una lista
     HOST = parole[0]         #la prima parola è l'indirizzo IP dell'host (l'apparato di rete)
     user = parole[1]         # la seconda parola è lo username
     password = parole[2]     # la terza parola è la password
     #print (HOST, user, password)
#-----------------------------------------------------------------------------------
     # esegui comandi ping diversi a seconda che la piattaforma sia Windows o LINUX
     if sist_operativo == "Windows":
          pinga = subprocess.call("ping -n 2 -w 500 " + HOST)  # fai due richieste di eco perché la prima potrebbe fallire per via dei ritardi causati dal protocollo ARP
     else:
          pinga = os.system("ping -c 2 " + HOST)    # con Ubuntu funziona questo
          #pinga = subprocess.call("ping -c 2 " + HOST)
     #print (pinga)
     if pinga == 0:                                # l'host ha risposto al ping
         print ("l'host " + HOST + " risponde \n")
         #  apri una connessione telnet con l'host e inviagli il comando per copiare la startup-config nel server tftp
         connessione = telnetlib.Telnet(HOST)
         # aspetta la richiesta di Username e inviaglielo
         connessione.read_until(b"Username: ") #Attendi la richiesta di username in byte (b)
         connessione.write((user + "\n").encode())
         # aspetta la richiesta di password e inviagliela
         connessione.read_until(b"Password: ")        #Attendi la richiesta di password in byte (b)
         connessione.write((password + "\n").encode())
         # invia i comandi
         connessione.write(("copy startup-config tftp://" + servertftp + "\n").encode()) #comando inviato in modalità byte
         connessione.write(b"\n")  #accetta l'indirizzo IP  proposto
         connessione.write(b"\n")  #accetta il nome del file proposto
         #verifica che il file della configurazione sia stato effettivamente salvato nel server TFTP
         leggirisposta = (connessione.read_until(b")").decode())
         print ("Messaggi scambiati col server TFTP: \n" )
         print (leggirisposta)
         salvareport.write("Messaggi scambiati col server TFTP: \n")
         salvareport.write(leggirisposta + "\n")
         #
         #------------------- verifica se nei messaggi scambiati c'è una indicazione di errore nel trasferimento del file
         #
         for cercaerrore in leggirisposta.split(): #separa con split() le singole parole contenute nella risposta e cerca i messaggi di errore
             #print (cercaerrore)
             if cercaerrore == "TFTP:":
            #segnala errore
               print ("-------------------------------------------------------------------------- ")
               print ("ATTENZIONE! Non è stato possibile salvare il file di configurazione sul server TFTP! \n")
               print ("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("ATTENZIONE! Non è stato possibile salvare il file di configurazione sul server TFTP! \n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               break
             elif cercaerrore == "%Error":
               print ("-------------------------------------------------------------------------- ")
               print ("ATTENZIONE! Non è stato possibile salvare il file di configurazione sul server TFTP \n  ")
               print ("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("ATTENZIONE! Non è stato possibile salvare il file di configurazione sul server TFTP! \n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               break
             elif cercaerrore == "bytes/sec)":  #non ci sono errori il trasferimento è stato completato
               connessione.write(b"exit\n")  #esce dalla sessione telnet e ripete tutto il ciclo
                                   #fino a quando non si è raggiunta la fine del file e si ha esci = s
               print ("-------------------------------------------------------------------------\n")
               print("E' STATO FATTO IL BACKUP SUL SERVER TFTP " + servertftp + " DELLA CONFIGURAZIONE DELL'APPARATO: " + (HOST) + "\n")
               print ("-------------------------------------------------------------------------\n")
               salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
               salvareport.write("E' STATO FATTO IL BACKUP SUL SERVER TFTP " + servertftp + " DELLA CONFIGURAZIONE DELL'APPARATO: " + (HOST) + "\n")
               salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
     else:   # se il ping fallisce viene restituito un numero >0
         print ("-----------------------------------------------------------------------------------\n")
         print ("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         print ("-----------------------------------------------------------------------------------\n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
         salvareport.write("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
#
 uscita = input("Vuoi uscire [s/n]: ")
 print ("--------------------------------------------------------------\n")
 #
 esci = uscita[0]  #considera solo il primo carattere digitato
 esci = esci.lower()
 salvareport.close #chiudi il file del report
print ("Grazie per aver usato il programma!")
exit()
