#-----------------------------------------------------------------------------------------------
print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
import telnetlib
import sys
import os
import platform
import subprocess
import time
#-----------------------------------------------------------------------------------------------------
print ( )
print ("+" * 100 + "\n")
print("Script Python 3.x per il caricamento da un server TFTP della startup-config su degli apparati Cisco,")
print("leggendone indirizzi IP, username e password da un file.")
print("Il file deve avere il seguente formato (va usato come separatore uno spazio):")
print("la prima riga deve contenere l'indirizzo IP del server TFTP")
print("le altre righe del file contengono <Indirizzo IP> <username> <password> di ciascun apparato \n")
print("esempio di file: \n")
print("10.0.0.150")
print("10.0.0.248 itis majorana")
print("10.0.0.200 userpippo passwordpippo \n")
print ("+" * 100 + "\n")
print(" Programma realizzato da Onelio Bertazioli \n")
print ("+" * 100 + "\n")
#--------------------------------------------------------------------------------------------------------
#funzione che esegue un ping sull'indirizzo IP passato come parametro
sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
def ping(indip):
    if sist_operativo == "Windows":
       pinga = subprocess.call("ping -n 2 -w 500 " + indip)  # fai due richieste di echo (la prima può fallire) con timeout di 500 ms
    else:
       pinga = os.system("ping -c 2 " + indip)      # con Ubuntu funziona questo
    return pinga
#---------------------------------------------------------------------------------------------------
esci = "n"
while esci != "s": #FINO A QUANDO esci è diverso da "s" continua a ripetere il ciclo 
 #print("-" *100 + "\n")
 print ("  n--> si usa il file di default; ")
 print ("  s --> fornire il nome del file e l'eventuale percorso (se non è nella stessa directory dello script)) \n")
 sceltafile = input("Vuoi fornire un nuovo file con gli indirizzi IP, username e password? [s/n] ")
 print("-" *100 + "\n")
 if sceltafile == "s":
    nomefile = input("Percorso e nome del file con gli indirizzi IP, username e password: ")
 else:
    nomefile = "fileipuserpw.csv" #nome di default del file da aprire
 print("-" *100 + "\n")
#determina data e ora da inserire nel report del nome del file
 orario = time.strftime("%H:%M")
 oranome = time.strftime("%H_%M")
 data = time.strftime("%d-%m-%Y")
 print ("data_" + str(data) + "_ora_" + str(orario))
#--------------------------------------------------------------------------------------------------------
# apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
 salvareport = open("Report_caricamento_data_" + str(data) + "_ora_" + str(oranome) + "_.txt", "w")
 salvareport.write("-------------------------------------------------------------\n")
 salvareport.write("Script Python 2.7 per il caricamento su un server TFTP della startup-config di apparati Cisco,\n")
 salvareport.write("leggendone indirizzi IP, username e password da un file. \n")
 salvareport.write("------------------------------------------------------------- \n")
 salvareport.write(" Script realizzato da Onelio Bertazioli " + "\n")
 salvareport.write("-------------------------------------------------------------\n")
 salvareport.write("Data: " + str(data) + " Ora: " + str(orario)) #scrivi nel file la data e l'ora del caricamento
 salvareport.write("\n")
#
#-------------- Inizia leggendo i dati contenuti nel file: ind. IP server TFTP, ecc.-----------------------------------
#la prima riga del file contiene l'indirizzo IP del server TFTP
 file = open(nomefile)      #apri il file e mettine il contenuto nella variabile file
 indip = file.readline()    # leggi la prima riga del file, che contiene l'indirizzo IP DEL SERVERTFTP
 servertftp = indip.strip() #metti nella varibile servertftp l'indirizzo IP del server TFTP; con strip() si elimina il <cr> finale che manda a capo
 #
 print ("Nome del file: " + nomefile)
 print ("Server TFTP: " + servertftp)
 print("-" *100 + "\n")
 #salva nel report
 salvareport.write("Nome del file: " + nomefile + "\n")
 salvareport.write("Server TFTP: " + servertftp + "\n")
 salvareport.write("-------------------------------\n")
 #
 # VERIFICA CON UN PING CHE IL SERVER TFTP SIA RAGGIUNGIBILE
 
 esitoping = ping(servertftp)  # effettua il ping richiamando la funzione ping(indip) che restituisce come risultato l'esito del ping
 if esitoping == 0:                                 # SE IL PING HA SUCCESSO RESTITUISCE 0
    print ("Il server TFTP " + servertftp + " è funzionante! \n")
    salvareport.write("Il server TFTP " + servertftp + " è funzionante! \n")
 else:
    print("-" *100 + "\n")
    print ("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE!\n")
    print ("IMPOSSIBILE EFFETTUARE IL caricamento! LO SCRIPT VIENE TERMINATO!\n")
    print("-" *100 + "\n")
    salvareport.write("-----------------------------------------------------------------------\n")
    salvareport.write("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE! \n")
    salvareport.write("IMPOSSIBILE EFFETTUARE IL caricamento! LO SCRIPT VIENE TERMINATO! \n")
    salvareport.write("-----------------------------------------------------------------------\n")
    uscita = input("Premere <invio> per continuare! ")
    esci = "s"
    break
#--------------------------------------------------
# leggi indirizzo IP, username e password degli apparati (A PARTIRE DALLA SECONDA RIGA)
 #
 for riga in file:             
     parole = riga.split()    #split() separa le singole parole contenute nella riga e le mette in una lista
     HOST = parole[0]         #la prima parola è l'indirizzo IP dell'host (l'apparato di rete)
     user = parole[1]         # la seconda parola è lo username
     password = parole[2]     # la terza parola è la password
     #print (HOST, user, password)
#-----------------------------------------------------------------------------------
     # esegui comandi ping diversi a seconda che la piattaforma sia Windows o LINUX
     esitoping = ping(HOST)
     if esitoping == 0:                                # l'host ha risposto al ping
         print ("l'host " + HOST + " risponde \n")
         #  apri una sessione telnet con l'host e inviagli il comando per copiare la startup-config nel server tftp
         connessione = telnetlib.Telnet(HOST)
         # aspetta la richiesta di Username e inviaglielo
         connessione.read_until(b"Username: ")
         connessione.write((user + "\n").encode())
         # aspetta la richiesta di password e inviagliela
         connessione.read_until(b"Password: ")
         connessione.write((password + "\n").encode())
# --------------------
         #
         hostname = connessione.read_until(b"#").decode()  #scrivi in hostname tutto quello che arriva fino a # cioè il nome del router + cancelletto
         nome = hostname.split()  #elimina tutti gli spazi con split
         #print ("nome: " + name[0])
         nomehost = nome[0].strip("#") # elimina il # finale dalla prima parola della lista nome: nome[0] (lista creata con lo split())
         #
         print ("----------------------------------------------------------------------------------------\n")
         print("CARICAMENTO DAL SERVER TFTP " + servertftp + " DELLA STARTUP-CONFIG DI: " + (HOST) + "\n")
         print ("----------------------------------------------------------------------------------------\n")
         print ("Hostname: " + (nomehost) + "  ; Indirizzo IP: " + HOST + "\n")
         #
         salvareport.write("\n")
         salvareport.write("Hostname: " + (nomehost) + " ; Indirizzo IP: " + HOST + "\n")
         salvareport.write("\n") 
         salvareport.write("CARICAMENTO DAL SERVER TFTP " + servertftp + " DELLA STARTUP-CONFIG DI: " + (HOST) + "\n")
         salvareport.write("\n")
         #
#-------------------> invia i comandi ------
         comandotftp = ("copy tftp://" + servertftp + "/" + (nomehost) + "-confg startup-config \n") #comando da inviare
         connessione.write(comandotftp.encode()) # manda il comando 
         connessione.write(b"\n")       #accetta il nome di default proposto: è come premere il tasto invio
         #
         print ("Comando dato: " +  comandotftp + "\n")
         salvareport.write("\n")
         salvareport.write("Comando dato: " +  comandotftp + "\n")
         salvareport.write("\n")  
         #
# -------> verifica che il file della configurazione sia stato effettivamente salvato nel server TFTP
         leggirisposta = connessione.read_until(")").decode()
         print ("Messaggi scambiati col server TFTP: \n" )
         print (leggirisposta)
         salvareport.write("Messaggi scambiati col server TFTP: \n")
         salvareport.write(leggirisposta + "\n")
         #
         #------------------- verifica se nei messaggi scambiati c'è una indicazione di errore nel trasferimento del file
         #
         for cercaerrore in leggirisposta.split(): #separa con split() le singole parole contenute nella risposta e cerca i messaggi di errore
             #print (cercaerrore)
             if cercaerrore == "TFTP:": #se nei messaggi scambiati è presente la parola TFTP: c'è stato un errore
               #segnala errore
               print ("-------------------------------------------------------------------------- ")
               print ("ATTENZIONE! Non è stato possibile caricare il file di configurazione dal server TFTP! \n")
               print ("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("ATTENZIONE! Non è stato possibile caricare il file di configurazione dal server TFTP! \n")
               salvareport.write("--------------------------------------------------------------------------\n")
               salvareport.write("\n")
               break
             elif cercaerrore == "%Error": #se nei messaggi scambiati è presente la parola %Error c'è stato un errore
               #segnala errore   
               print ("\n")
               print ("---------------------------------------------------------------------")
               print ("ATTENZIONE! Non è stato possibile caricare il file di configurazione dal server TFTP! ")
               print ("---------------------------------------------------------------------\n")
               salvareport.write("ATTENZIONE! Non è stato possibile caricare il file di configurazione dal server TFTP!")
               salvareport.write("\n")
               break
             elif cercaerrore == "Loading":  #se nei messaggi scambiati è presente la parola Loading non ci sono errori; il trasferimento è avviato
               connessione.read_until(b")")#se non si trova l'indicazione di errore aspetta fino a quando ha finito di caricare la configurazione
               connessione.write(b"\n")  #manda un <invio> per andare a capo
               #salva di nuovo la configurazione nel server TFTP per tenere conto di un eventuale cambio di hostname
               connessione.write(("copy startup-config running-config" + "\n").encode()) #copia la startup-config nella running-config
               connessione.write(b"\n") #accetta il nome di default proposto
               connessione.write(("copy startup-config tftp://" + servertftp + "\n").encode()) #copia la rstartup-config nel server TFTP, in modo da aggiornare il nomefile se l'hostname è cambiato
               connessione.write(b"\n")  #accetta il nome di default proposto
               connessione.write(b"\n")  #accetta il nome di default proposto
               connessione.write(b"exit\n")  # chiudi la connessione Telnet
               #
               print ("--------------------------------------------------------------------------------------")
               print (" Startup-config dell'host " + nomehost + " IP " + HOST + " correttamente aggiornata!  ")
               print (" Configurazione caricata nella running-config!                                        ")
               print (" Startup-config salvata anche nel server TFTP!                                        ")     
               print ("--------------------------------------------------------------------------------------\n")
               #
               salvareport.write("\n")
               salvareport.write("-------------------------------------------------------------------------------------- \n")
               salvareport.write("\n")
               salvareport.write("Startup-config correttamente aggiornata! Configurazione caricata nella running-config! \n")
               salvareport.write("Startup-config correttamente salvata anche nel server TFTP! \n")
               salvareport.write("\n")
               salvareport.write("-------------------------------------------------------------------------------------- \n")
               salvareport.write("\n")
#--------------------------------------------------------------------------------------
     else:   # se il ping fallisce viene restituito un numero >0
         print ("-----------------------------------------------------------------------------------\n")
         print ("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         print ("-----------------------------------------------------------------------------------\n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
         salvareport.write("L'apparato di rete " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
         salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
# ----------------------------------- fine delle configurazioni; chiedi se uscire o continuare con un altro file -------------------------------
 uscita = input("Vuoi uscire [s/n]: ")
 print ("--------------------------------------------------------------\n")
 #
 esci = uscita[0]  #considera solo il primo carattere digitato
 if esci == "S":   #trasforma l'eventuale maiuscola in minuscola
    esci = "s"
 salvareport.close #chiudi il file del report
print ("Grazie per aver usato il programma")
