# -*- coding: iso-8859-1 -*-
#
#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
#---------------- MODULI DA IMPORTARE -------------------------------------------------------
import getpass  #gestisce l'acquisizione della password
from sys import exit
import sys
import telnetlib  #gestisce la connessione via Telnet
import os
import platform
import subprocess
import time
#-----------------------------------------------------------------------
print("------------------------------------------------------------------------\n")
print("    Programma Python 3.x per la configurazione via Telnet di apparati Cisco")
print("------------------------------------------------------------------------")
print("    Realizzato da Onelio Bertazioli"                              )
print("------------------------------------------------------------------------\n")
#
# ------------------ crea un ciclo che consente di configurare pi apparati finch non si sceglie di uscire
#
esci = "n"
while esci != "s": #FINO A QUANDO esci  diverso da "s" continua a ripetere il ciclo
 print(" \n")
 HOST = input("indirizzo IP dell'apparato: ") # chiedi l'indirizzo IP e mettilo nella variabile HOST
#
 servertftp =  input("indirizzo IP del server TFTP: ")
 #servertftp = "10.10.7.254"   #decommentare se l'indirizzo IP del server tftp  assegnato nel programma
 # -------------------- operazioni preliminari: tipo di sistema operativo, data e ora -------------------
 sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
 #
 #determina data e ora da inserire nel report del nome del file
 orario = time.strftime("%H:%M")
 oranome = time.strftime("%H_%M")
 data = time.strftime("%d-%m-%Y")
 print ("data_" + str(data) + "_ora_" + str(orario) + " \n")

 #-------------------------------------------------------------------------------------------------------
 # apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
 # ------------------------------------------------------------------------------------------------------
 file_report = open("Report_configurazione_data_" + str(data) + "_ora_" + str(oranome) + "_.txt", "w")
 file_report.write("Data: " + str(data) + " Ora: " + str(orario)) #scrivi nel file la data e l'ora della configurazione
 file_report.write(" \n")
 file_report.write(" ------------------------------------------------  \n")
#------------------------------------------------------------------
# VERIFICA CON UN PING CHE L'APPARATO SIA RAGGIUNGIBILE
#------------------------------------------------------------------
 print("-------------------------------------------------------------")
 print("     VERIFICO CON UN PING CHE L'APPARATO SIA RAGGIUNGIBILE \n")
 #
 if sist_operativo == "Windows":
    pinga = subprocess.call("ping -n 1 -w 500 " + HOST)
 else:
    pinga = os.system("ping -c 1 " + HOST) # per sistemi operativi LINUX
    # 
    #
 if pinga == 0:
    print ("  L'apparato " + HOST + " risponde! \n")
    file_report.write("  L'apparato " + HOST + "  raggiungibile! \n")
    file_report.write("\n")
    file_report.write("---------------------------------------------------------------------------------------------\n")
    file_report.write(" \n")
    esci = "n"
 else:
    print ("--------------------------------------------------------------------------------------------------------\n")
    print ("  ATTENZIONE: L'apparato " + HOST + " NON RISPONDE!\n")
    print ("-------------------------------------------------------------------------\n")
    file_report.write("  ATTENZIONE: L'apparato  " + HOST + " NON E' RAGGIUNGIBILE! \n")
    file_report.write("---------------------------------------------------------------------------------------------\n")
    uscita = input("  Premere <invio> per continuare! ")
    esci = "s"
#------------------------------------------------------------------
# connessione via Telnet all'apparato
#------------------------------------------------------------------
 if esci == "n":
    print("----------------------------------------------------\n")
    print("  Connessione Telnet all'host: " + HOST)
    print("----------------------------------------------------\n")
    connessione = telnetlib.Telnet(HOST)  # apre la connessione telnet
    ciclo = "s" #continua a chiedere username e password 
    numciclo = 0
    while ciclo == "s": 
      numciclo = numciclo +1 
      #
      user = input("Username: ") #chiedi username
      password = getpass.getpass()   #chiedi password
      #
      #
      connessione.read_until(b"Username: ")  #aspetta di ricevere la richiesta di username
      connessione.write((user + "\n").encode())        #trasmetti lo username + <invio> (con "\n")    
      if password:
         connessione.read_until(("Password: ").encode())
         connessione.write((password + "\n").encode())
         leggirisposta = connessione.read_some()  #memorizza la risposta inviata
         leggirisposta = leggirisposta.decode()
         #
         #------------------- verifica se nei messaggi scambiati c' una indicazione di username o password non validi
         cercaerr = 0          #puntatore per cercare l'inizio di una segnalazione di errore
         segnalaerr = ""   #variabile usata per cercare una eventuale segnalazione di login non valido
         for cerca in leggirisposta:  #cerca nei messaggi scambiati il carattere % che indica l'inizio di un login errato
            errore = leggirisposta[cercaerr]
            #
            if errore == "%":
               if numciclo == 2:  # se  la seconda volta che il login  erato chiude la connessione
                    print ("  ATTENZIONE: USERNAME E PASSWORD ANCORA ERRATI! La connessione viene chiusa \n")
                    file_report.write("  ATTENZIONE: USERNAME E PASSWORD ANCORA ERRATI! La connessione viene chiusa \n")
                    ciclo = "n"
                    break
               #print ("errore " + errore)
               print ("-------------------------------------------------------------------------- ")
               print ("  Attenzione: USERNAME o PASSWORD ERRATI! ")
               print ("--------------------------------------------------------------------------\n")
               file_report.write("  Attenzione: USERNAME o PASSWORD ERRATI! \n")
               ciclo = "s" #esci dal ciclo
               break
            cercaerr = cercaerr + 1
         #
# ---------------- se non ci sono errori invia i comandi --------------------
         if errore != "%":
            print (" --------------------- Invio i comandi all'apparato ------------------ \n")
            file_report.write(" Invio i comandi all'apparato  \n")
            connessione.write(("terminal length 0 \n").encode())  # evita interruzioni nell'invio delle configurazioni
            #connessione.write(("configure terminal" + "\n").encode())
            #connessione.write(("ip route 0.0.0.0 0.0.0.0 10.0.0.1\n").encode())
            #connessione.write(("host router-"+ HOST +"-lab_tele" + "\n").encode())
            # altri comandi 
            #connessione.write(b"end\n")
            connessione.write(("show run" + "\n").encode()) #mostra la configurazione in esecuzione
            #connessione.write(("copy run start" + "\n").encode()) # copia la configurazione in esecuzione in quella di avvio
            #connessione.write(("startup-config" + "\n").encode()) # nome del file con la configurazione di avvio
            #  SALVA LA CONFIGURAZIONE ANCHE NEL SERVER TFTP
            connessione.write(("copy startup-config tftp://" + servertftp + "\n").encode()) #copia la runningconfig nel server TFTP, in modo da aggiornare il nomefile se l'hostname  cambiato
            connessione.write(("\n").encode())
            connessione.write(("\n").encode())
            # FINE DELLA CONFIGURAZIONE; ESCI
            connessione.write(("exit\n").encode())
            ciclo = "n"
            report = connessione.read_all().decode() #salva in report tutto quello che viene scambiato
            print("-------------------------------------------------------------")
            print("     VISUALIZZO IL REPORT DEI MESSAGGI SCAMBIATI \n")
            print (report)
            print("----------------- FINE DEL REPORT -------------------------------------------")
            file_report.write("---------------- REPORT DEI MESSAGGI SCAMBIATI --------------- \n")
            file_report.write(report) # salva anche nel file di report
 uscita = input("Vuoi uscire [s/n]: ")
 print ("--------------------------------------------------------------\n")
 #
 esci = uscita[0]  #considera solo il primo carattere digitato
 esci = esci.lower()   #trasforma l'eventuale maiuscola in minuscola
file_report.close #chiudi il file del report
print ("Grazie per aver usato il programma")
exit()
