#-----------------------------------------------------------------------------------------------------
print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
from sys import exit
import csv
import platform
import subprocess
import time
import ipaddress   # serve per determinare indirizzi IP di rete, di tutti gli host della rete IP, di broadcast ecc.
import requests  
import os
print("\nProgramma che visualizza gli indirizzi MAC delle schede di rete del proprio PC")
print("---------------------------------------------------------------------------------------------------")
print("Programma realizzato da Onelio Bertazioli")
print("---------------------------------------------------------------------------------------------------")
#
def cercavendor(mac):  # funzione che determina il vendor della scheda con il mac indicato
    #il sito contenuto nell'URL è in grado di fornire un file in formato .csv che contiene il nome del costruttore della scheda di cui è noto l'ind. MAC
    url = "http://macvendors.co/api/" + mac + "/csv"   #nell'url chiedi che la risposta sia una stringa in formato .csv
    risposta = requests.get(url)                       #chiedi come risposta il costruttore della scheda di cui si fornisce il mac
    risposta = risposta.text   #metti in risposta il testo della risposta
    leggivendor = csv.reader(risposta, delimiter=",")  #usa il metodo .reader del modulo csv per trovare il costruttore
    n=0
    for riga in leggivendor:
        if n==0:
           vendor=riga[0]   # leggi solo la prima riga che è quella con il nome del costruttore
           n=n+1
    return  vendor     #la funzione restituisce la stringa che contiene il nome del costruttore
#---------------------------------------------------------------------
def comando_windows(comando):
    if sist_operativo == "Windows":
       out = subprocess.check_output(comando)  # invia il comando al sistema operativo e salva la risposta 
       output_comando = out.split() #crea una lista contenete tutte le singole parole dell'output espresse come byte
       k = 0 
       for parola in output_comando:
           parola = str(parola,"iso-8859-1")  # converte ogni parola da byte a stringa 
           output_comando[k] = parola
           k = k+1
       return output_comando
    else:
      print("Attenzione! Per ora il programma funziona solo per sistemi operativi Windows!")
      print("*"*110 + "\n")
      esci = input("Premere un tasto per uscire!")
      exit
      return 
#----------------------------------------------------
sist_operativo = platform.system()
out = comando_windows("ipconfig /all") # analisi dell'output di ipconfig /all
output = []
k = 0
m=0
for parola in out:  # togli tutte le parole uguali a "." e ":"
    if parola != "." and parola != ":":
       output.insert(m,out[k])
       output[m] = output[m].strip(".")  #togli anche l'eventuale "." finale della parola
       m = m+1
    k = k+1
#
print("\nLe schede di rete del tuo PC sono queste: \n")
out = subprocess.check_output("getmac /FO csv /V ") 
out=out.decode()
print("Indirizzi MAC delle schede di rete del PC: ")
with open("out.csv","w", newline='') as file:
    file.write(out)
with open("out.csv","r") as filecsv:
    leggifile = csv.reader(filecsv, delimiter=",")
    for riga in leggifile:
       if riga[0] == "Nome connessione":
            pass      
       else:
            tipo_scheda=riga[0]
            if riga[2] == "Disattivato":
                print(tipo_scheda + ": Scheda disattivata\n")
                mac_scheda = ""
            else:
                mac=riga[2]# in notazione windows
                mac_scheda=riga[2].replace("-",":")# cambia separatore
                vendor=cercavendor(mac_scheda)
                attiva="si"
                if riga[3]=="Supporto disconnesso":
                    attiva="no"
                if attiva =="si":#cerca l'indirizzo IP della scheda attiva
                    k = 0
                    for parola in output:
                        if parola == mac:
                            for n in range(1,20):
                                if output[k+n] == "IPv4":
                                    ind_IP=output[k+n+1].strip("(Preferenziale)")
                            break
                        k = k+1
            if mac_scheda != "":
              print("Scheda: "+ tipo_scheda + "; indirizzo MAC : " + mac_scheda + "; vendor: "+ vendor +"; attiva: "+ attiva +"\n")
              if attiva =="si":
                print("Indirizzo IP della scheda attiva:",ind_IP)
            
os.remove("out.csv")
print("\n +++++++++++++++++++++++++ FINE +++++++++++++++++++++++++++++++++++++++++++++++++++")
#fine=input("premere un tasto per uscire")
exit()
