#-----------------------------------------------------------------------------------------------------
print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("\n")
print("*"*110 +"\n")
print("Programma in Python 3.x per l'analisi della configurazione di un PC in formato decimale e binario con determinazione \n")
print("dell'indirizzo di rete, del numero massimo di host, dell'indirizzo di broadcast e della wildcard mask\n")
print("*"*110 +"\n")
print(" Realizzato da Onelio Bertazioli \n")
# ------------------ Moduli da importare
from sys import exit
import os
import csv
import platform
import subprocess
import time
import ipaddress   # serve per determinare indirizzi IP di rete, di tutti gli host della rete IP, di broadcast ecc.
import requests    # serve per cercare su un sito i nomi dei costruttori delle schede di cui si ha l'indirizzo MAC
#----------------- FUNZIONI DEFINITE -----------------------------------
def cercavendor(mac):  # funzione che determina il vendor della scheda con il mac indicato
    #il sito contenuto nell'URL è in grado di fornire un file in formato .csv che contiene il nome del costruttore della scheda di cui è noto l'ind. MAC
    url = "http://macvendors.co/api/" + mac + "/csv"   #nell'url chiedi che la risposta sia una stringa in formato .csv
    risposta = requests.get(url)                       #chiedi come risposta il costruttore della scheda di cui si fornisce il mac
    risposta = risposta.text   #metti in risposta il testo della risposta
    leggivendor = csv.reader(risposta, delimiter=",")  #usa il metodo .reader del modulo csv per trovare il costruttore
    n=0
    for riga in leggivendor:
        if n==0:
           vendor=riga[0]   # leggi solo la prima riga che è quella con il nome del costruttore
           n=n+1
    return  vendor     #la funzione restituisce la stringa che contiene il nome del costruttore 
#------------------
def comando_windows(comando):
    if sist_operativo == "Windows":
       out_comando = subprocess.check_output(comando)  # invia il comando al sistema operativo e salva la risposta 
       output_comando = out_comando.split() #crea una lista contenete tutte le singole parole dell'output espresse come byte
       k = 0 
       for parola in output_comando:
           parola = str(parola,"iso-8859-1")  # converte ogni parola da byte a stringa 
           output_comando[k] = parola
           k = k+1
       return output_comando
    else:
      print("Attenzione! Per ora il programma funziona solo per sistemi operativi Windows!")
      print("*"*110 + "\n")
      esci = input("Premere un tasto per uscire!")
      exit
      return
#--------------------------------------------------------------
def aprifile(nomefile,hostname):
    file = open(nomefile, "w")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.write("Programma in Python 3.x per l'analisi della configurazione di un PC in formato decimale e binario\n")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.write(" Programma realizzato da Onelio Bertazioli \n")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.close()
    return nomefile
#------------------------------------------------------------------------
def cerca_config_ip(comando):  #chiede al s.o. gli ind. mac delle schede, individua la scheda attiva, cerca in ipconfig /all la config IP della scheda attiva
    output = []
    k = 0
    m=0
    for parola in comando:  # togli tutte le parole uguali a "." e ":"
        if parola != "." and parola != ":":
           output.insert(m,comando[k])
           output[m] = output[m].strip(".")  #togli anche l'eventuale "." finale della parola
           m = m+1
        k = k+1
    #cerca la scheda attiva
    k=0
    for cercahost in output:  # cerca l'hostname
        if cercahost == "host":
            hostname=output[k+1]
            break
        k=k+1
    nomefile="configurazione_pc_" + hostname +"_data_"+ str(data) + "_ora_" + str(oranome) + ".txt"
    aprifile(nomefile,hostname)
    print("File di report: ")
    print(nomefile + "\n")
    print("*"*42 +" Schede di rete rilevate " + "*"*42 + "\n")
    #cerca la scheda attiva
    out = subprocess.check_output("getmac /FO csv /V ") #chiedi gli indirizzi MAC delle schede di rete con l'ouput in formato .csv
    out=out.decode()
    with open("out.csv","w", newline='') as file:  # scrivi gli ind. mac in un file .csv
        file.write(out)
    with open("out.csv","r") as filecsv:
      leggifile = csv.reader(filecsv, delimiter=",")
      continua ="no"
      for riga in leggifile: #verifica che ci sia almeno una scheda attiva
          if riga[0] == "Nome connessione":
                pass    #è la prima riga non fare niente
          else:
                riga[3] != "Supporto disconnesso"
                continua="si"
    #------------------------
    if continua =="si":
      with open("out.csv","r") as filecsv:  #apri il file, cerca gli indirizzi MAC delle schede, cerca la scheda attiva e la sua config. IP
        leggifile = csv.reader(filecsv, delimiter=",")
        for riga in leggifile:
            if riga[0] == "Nome connessione":
                pass    #è la prima riga non fare niente  
            else:
                conf_salvata ="no"
                file = open(nomefile, "a")
                tipo_scheda=riga[0]
                #
                mac=riga[2]# in notazione windows
                #
                mac_scheda=riga[2].replace("-",":")# cambia separatore per ricerca vendor
                vendor=cercavendor(mac_scheda)
                print("Scheda ",tipo_scheda," ; ind. MAC: ",mac_scheda, " ; vendor: ", vendor)
                file.write("*"*42 +" Scheda di rete rilevata " + "*"*42 + "\n")
                file.write("Scheda " + tipo_scheda + " ; ind. MAC: "+ mac_scheda + " ; vendor: " + vendor + "\n")
                attiva="si"
                if riga[3]=="Supporto disconnesso":
                    attiva="no"
                print("Scheda attiva: ", attiva + "\n")
                file.write("Scheda attiva: " + attiva + "\n")
                #file.write("*"*110 + "\n")
                #
                k=0
                if attiva =="si":#cerca l'indirizzo IP della scheda attiva e salva solo la configurazione della prima scheda attiva trovata
                  if conf_salvata =="no":
                    fineciclo="no"
                    for parola in output:
                        #if output[k] == "NetBIOS":
                         #           break   #quando iniziano i parametri della scheda successiva interrompi
                        #   
                        if parola == mac:
                            for n in range(1,1000):
                                if output[k+n] == "IPv4":
                                    ind_IP=output[k+n+1].strip("(Preferenziale)")
                                    #
                                    mask=output[k+n+4]
                                elif output[k+n] == "predefinito":
                                    gateway=output[k+n+1]
                                elif output[k+n] == "DNS":
                                    dns=output[k+n+1]
                                    fineciclo="si"
                                    break
                                    #
                        if fineciclo=="si":
                            break
                        k = k+1 #continua la ricerca dei parametri IP
                    file.close()        
                    configip=[] #metti la configurazione IP in una lista
                    configip.insert(0,hostname)
                    configip.insert(1,mac_scheda)#aggiungi anche l'ind. MAC della scheda
                    configip.insert(2,ind_IP)
                    configip.insert(3,mask)
                    configip.insert(4,gateway)
                    configip.insert(5,dns)
                    conf_salvata =="si"
      os.remove("out.csv")# elimina il file creato              
    else:
      print("tutti i supporti sono disconnessi!")
      file = open(nomefile, "a")
      file.write("*"*110 + "\n")
      file.write("\n")
      file.write("Attenzione! Tutte le schede di rete sono disconnesse!! \n")
      file.write("\n")
      file.write("*"*110 + "\n")
      file.write("\n")
      file.write("*"*110 + "\n")
      file.close()
      exit()
    #
    return configip,nomefile #restituisce una lista con config IP e nome del file
#---------------------------------------------------
def stampaconfig(conf_ip,nomefile):
    print("*"*110 + "\n")
    print("Configurazione del PC attiva: \n")
    print("Nome host           => " + conf_ip[0] + "\n")
    print("Ind. MAC scheda     => " + conf_ip[1] + "\n")
    print("Indirizzo IP        => " + conf_ip[2] + "\n")
    print("Subnet mask         => " + conf_ip[3] + "\n")
    print("Gateway predefinito => " + conf_ip[4] + "\n")
    print("Server DNS          => " + conf_ip[5] + "\n")
    #print("*"*110 + "\n")
    file = open(nomefile, "a")
    file.write("*"*110 + "\n")
    file.write("Configurazione del PC attiva: \n")
    file.write("Nome host               => " + conf_ip[0] + "\n")
    file.write("Ind. MAC scheda     => " + conf_ip[1] + "\n")
    file.write("Indirizzo IP              => " + conf_ip[2] + "\n")
    file.write("Subnet mask           => " + conf_ip[3] + "\n")
    file.write("Gateway predefinito => " + conf_ip[4] + "\n")
    file.write("Server DNS             => " + conf_ip[5] + "\n")
    #file.write("*"*110 + "\n")
    file.close()
#---------------------------------------------------------------------------------------------------------------------------
def converti(numero):   #converti una cifra da decimale a binario e restituisci la stringa di 8 uni e zeri corrispondente 
    cifrabin = bin(numero)  #converte una cifra decimale in binario espressa come 0b11110000
    maskbin = str(cifrabin[2:])# togli lo 0b che precede la cifra in binario
    lung = len(maskbin)
    if lung == 8:         # se la cifra 
       return maskbin
    elif lung <<8:
         maskbina = maskbin + "0"*(8-lung)
         return maskbina
#----------------------------------------------------------------------------
def converti_ip(numero):   #converti una cifra da decimale a binario e restituisci la stringa di 8 uni e zeri corrispondente 
    cifrabin = bin(numero)  #converte una cifra decimale in binario espressa come 0b11110000
    ipbin = str(cifrabin[2:])# togli lo 0b che precede la cifra in binario
    lung = len(ipbin)
    if lung == 8:          
       return ipbin
    elif lung <<8:
         ipbina = "0"*(8-lung) + ipbin
         return ipbina
#---------------------------------------------------------------------------------------------------------------------------
def contauno(cifra): #conta il numero di 1 in una cifra decimale passata come stringa espressa in binario con 8 bit
    binario = converti(int(cifra)) # richiama la funzione che converte in binario la cifra 
    bina = str(binario)  #esprimi la cifra binaria come stringa 
    if cifra != "0":       #elimina tutti gli zeri presenti nella cifra se c'è almeno un 1
       for n in range(0,8):
           if bina[-1] == "0":
              bina = bina.strip("0")
           numuni = len(bina)
       return numuni
    elif cifra == "0":  # se la cifra decimale è 0 (espressa come stringa) restituissci 0 come numeri di 1
         numuni = 0
         return numuni
#-----------------------------------------------------------------------------------------------------
#funzione che esegue un ping sull'indirizzo IP passato come parametro
def ping(indip):
    #print(".")
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping " + indip + " -n 2 -w 200").returncode  # fai 2 richieste di echo (la prima può fallire) con timeout di 200 ms
    else:
       pinga = subprocess.run("ping " + indip + " -n 2 -w 200", shell=True).returncode      # con LINUX funziona questo
    return pinga
#- PROGRAMMA PRINCIPALE ----------------------------------------------------------------------
orario = time.strftime("%H:%M")
oranome = time.strftime("%H_%M")
data = time.strftime("%d-%m-%Y")
print("*"*110 + "\n")
print ("Data: " + str(data) + "; Ora: " + str(orario) + "\n")
#------------------------
sist_operativo = platform.system()
out_comando=comando_windows("ipconfig /all") #output di ipconfig /all
output_comando=cerca_config_ip(out_comando)   #cerca la configurazione IP e mettila in una lista: hostname [0], ind. MAC [1], ind IP [2], subnet mask [3], gateway [4], DNS [5]
config_ip=output_comando[0]
nomefile=output_comando[1]
stampaconfig(config_ip,nomefile)# stampa la config IP
indirizzo_ip=config_ip[2]
mask=config_ip[3]
#********************************************** INIZIO PROGRAMMA CHE DETERMINA L'INDIRIZZO DI RETE *******************************
print ("============ Analisi dell'indirizzo IPv4 e determinazione dell'indirizzo IPv4 di rete ===================\n")
print("Indirizzo IPv4 dell'host: " + indirizzo_ip + "\n")
file=open(nomefile, "a")
file.write("*"*110 + "\n")
file.write("\n")
file.write("Indirizzo IPv4 dell'host: " + indirizzo_ip + "\n")
#file.write("-"*110 +"\n")
file.write("\n")
#
print("Subnet mask: "+" "*10 + mask + "\n")
print("-"*110 +"\n")
file.write("Subnet mask: " + mask + "\n")
file.write("-"*110 +"\n")
file.write("\n")
#********************************************************************************************************************
cifre_mask = mask.replace(".", " ")  #sostituisci il punto con uno spazio in modo da poter creare una lista con il metodo split()
cifre_mask = cifre_mask.split()   #crea una lista che contiene le singole cifre decimali della subnet mask
#
primacifra = cifre_mask[0] # salta il punto che separa le cifre della subnet mask
secondacifra = cifre_mask[1]   #= int(mask[4:7])   # valore in decimale della seconda cifra
terzacifra = cifre_mask[2] #int(mask[8:11])  # valore in decimale della terza cifra
quartacifra = cifre_mask[3] #int(mask[12:16])  # valore in decimale della quarta cifra
#************************************************************************************************************************
#================================> conta gli 1 che ci sono in ciascuna cifra espressa come stringa e in binario
cifra1 = contauno(str(primacifra))   
cifra2 = contauno(str(secondacifra))
cifra3 = contauno(str(terzacifra))
cifra4 = contauno(str(quartacifra))
#================================>
lung_mask = int(cifra1) + int(cifra2)+ int(cifra3)+ int(cifra4) # numero totale di 1 presenti nella subnet mask
#================================>conversione in binario della subnet mask
c1 = converti(int(primacifra))    
c2 = converti(int(secondacifra))
c3 = converti(int(terzacifra))
c4 = converti(int(quartacifra))
#
maskbin = str(c1) + str(c2) + str(c3) + str(c4)  #subnet mask espressa in binario
#
#======================================================================================================================>
ind_ip = indirizzo_ip.replace(".", " ") #sostituisci il punto con uno spazio in modo da poter creare una lista
ind_ip= ind_ip.split() #crea una lista con le singole cifre dell'indirizzo IP
#------------------------------------------------------------------------------------------------------------------------
stripbin =[]  # inizializza una lista vuota
k=0
for cifra in ind_ip:
    stripbin[k:k] = [converti_ip(int(cifra))] #crea una lista che contiene le cifre dell'indirizzo IP espresse in binario
    k = k+1
ip_bin = ""  # inizializza una stringa in cui si metterà l'indirizzo IP espresso in binario
ip_bin = ip_bin.join(stripbin)  #crea una stringa riunendo tuttii campi della lista che contiene le singole cifre dell'IP
#
ind_rete = ip_bin[0:lung_mask] + "0"*(32-lung_mask) #prendi dall'indirizzp IPv4 un numero di bit pari alla lunghezza della subnet mask
#                                                   e falli seguire da tutti 0
cifra1_bin = ind_rete[0:8] #prendi i primi 8 bit e convertili in decimale
cifra1 = int(cifra1_bin, 2)
#
cifra2_bin = ind_rete[8:16] #prendi altri 8 bit e convertili in decimale
cifra2 = int(cifra2_bin, 2)
#
cifra3_bin = ind_rete[16:24] #prendi altri 8 bit e convertili in decimale
cifra3 = int(cifra3_bin, 2)
#
cifra4_bin = ind_rete[24:32] #prendi altri 8 bit e convertili in decimale
cifra4 = int(cifra4_bin, 2)
#
ind_rete_dec = str(cifra1) + "." + str(cifra2) + "." + str(cifra3) + "." + str(cifra4)     # metti insieme le cifre e aggiungi il punto di separazione
#------------------------------------------------------------------------------------------------------------------------------
print("Lunghezza della subnet mask: /" + str(lung_mask) + "\n")
file.write("Lunghezza della subnet mask: /" + str(lung_mask) + "\n")
file.write("\n")
print("Subnet mask espressa in binario:" + " "*4 + maskbin + "\n")
#
file.write("Subnet mask espressa in binario:" + " "*4 + maskbin + "\n")
#file.write("-"*110 +"\n")
#file.write("\n")
#
#print("-"*110 +"\n")
print("Indirizzo IPv4 in binario:" + " "*10 +ip_bin + "\n")
#
#print("-"*110 +"\n")
file.write("Indirizzo IPv4 in binario:      " + " "*11 +ip_bin + "\n")
#file.write("-"*110 +"\n")
#
print("Indirizzo IPv4 di rete in binario:" + " "*2 + ind_rete + "\n")
#
print("*"*110 +"\n")
#file.write("-"*110 +"\n")
file.write("Indirizzo IPv4 di rete in binario:    " + " "*2 + ind_rete + "\n")
file.write("\n")
#
ind_rete_cidr = ind_rete_dec + "/" + str(lung_mask)
print("Indirizzo IPv4 di rete in notazione CIDR: " + ind_rete_cidr + "\n")
#print("-"*110 +"\n")
file.write("Indirizzo IPv4 di rete in notazione CIDR: " + ind_rete_cidr + "\n")
#file.write("-"*110 +"\n")
#-------------------------------------------------------------------------------------------------------------------------------
# usa il modulo ipaddress per determinare indirizzi ip degli host, broadcast, ecc.
rete = ipaddress.ip_network(ind_rete_cidr)
#----------------------------------------------------------------------------------------------------------
max_num_host= rete.num_addresses-2  #calcola il numero massimo di indirizzi IPv4 utilizzabili per gli host
ind_broadcast = rete[-1]  #indirizzo IP di broadcast
inverse_mask = rete.hostmask
#----------------------------------------------------------------------------------------------------------
print("Inverse mask (o wildcard mask o host mask): " + str(inverse_mask) + "\n")
print("Numero totale di indirizzi IPv4 disponibili per gli host: " + str(max_num_host) + "\n")
print("Indirizzo IPv4 di broadcast: " + str(ind_broadcast) + "\n")
#
#file.write("-"*110 +"\n")
file.write("\n")
file.write("Inverse mask (o wildcard mask o host mask): " + str(inverse_mask) + "\n")
file.write("Numero totale di indirizzi IPv4 disponibili per gli host: " + str(max_num_host) + "\n")
file.write("Indirizzo IPv4 di broadcast: " + str(ind_broadcast) + "\n")
file.write("*"*50 + "  FINE   " + "*"*50 + "\n")
#------------------------------------------------------------------------------------------------------------
#input("Premere un tasto per terminare")
file.close()
print("*"*50 + "  FINE   " + "*"*50 + "\n")
#input("Premere un tasto per uscire! ")
exit()
