print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
print("------------------------------------------------------------------------\n")
print("    Programma in Python 3.7 per la configurazione via Telnet di apparati Cisco")
print("------------------------------------------------------------------------")
print("    Realizzato da Onelio Bertazioli"                              )
print("------------------------------------------------------------------------\n")
#---------------- MODULI DA IMPORTARE -------------------------------------------------------
import getpass  #gestisce l'acquisizione della password
import telnetlib  #gestisce la connessione via Telnet
import platform
import subprocess
import subprocess
import platform
from sys import exit
############
sist_operativo = platform.system()
def ping(indip):                    #funzione che esegue un ping sull'indirizzo IP passato come parametro
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping -n 2 -w 200 " + indip).returncode  # fai due richieste di echo (la prima può fallire) con timeout di 500 ms
    else:
       pinga = subprocess.run(("ping " + indip + " -c 2 -w 200"), shell=True).returncode      # con LINUX funziona questo
    return pinga
#
servertftp = input("indirizzo IP del server TFTP: ") # chiedi l'indirizzo IP del server TFTP per eventuali backup
# ------------------ crea un ciclo che consente di configurare più apparati finché non si sceglie di uscire
esci = "n"
while esci != "s": #FINO A QUANDO esci è diverso da "s" continua a ripetere il ciclo
 ind_IP = input("indirizzo IP dell'apparato: ") # chiedi l'indirizzo IP e mettilo nella variabile ind_IP
 #verifica con un ping per verificare che gli apparati siano raggiungibili!!!! 
 esitoping = ping(ind_IP)
 if esitoping != 0:  # l'host NON ha risposto al ping segnala ciò e termina
   print ("---------------------------------------------------------------------------------------------------\n")
   print ("ATTENZIONE! l'APPARATO " + ind_IP + " non risponde, potrebbe essere spento o non collegato in rete")
   print ("Il programma viene terminato!\n")
   print ("---------------------------------------------------------------------------------------------------\n")
   input("Premere Invio per terminare")
   exit()
 #
 esitoping = ping(servertftp)
 if esitoping != 0:  # l'host NON ha risposto al ping segnala ciò e termina
   print ("---------------------------------------------------------------------------------------------------\n")
   print ("ATTENZIONE! Il server TFTP " + servertftp + " non risponde, potrebbe essere spento o non collegato in rete")
   print ("Il programma viene terminato!\n")
   print ("---------------------------------------------------------------------------------------------------\n")
   input("Premere Invio per terminare")
   exit()
 #
 print("  Connessione Telnet all'ind_IP: " + ind_IP)
 connessione = telnetlib.Telnet(ind_IP)  # apre la connessione telnet
 user = input("Username: ") #chiedi username
 password = getpass.getpass()   #chiedi password
 connessione.read_until(b"Username: ")  #aspetta di ricevere la richiesta di username
 connessione.write((user + "\n").encode())        #trasmetti lo username + <invio> (con "\n") in formato byte    
 if password: #se è stata fornita la password
    connessione.read_until(b"Password: ")
    connessione.write((password + "\n").encode())  # invia in formato byte 
    print (" --------------------- Invio i comandi all'apparato ------------------ \n")
    connessione.write(b"terminal length 0" + b"\n")  # evita interruzioni nell'invio delle configurazioni
    connessione.write(b"configure terminal" + b"\n")
    connessione.write(("hostname apparato-"+ ind_IP +"-lab_telecom" + "\n").encode()) # cambia il nome host dell'apparato
    connessione.write(b"end" + b"\n")
    connessione.write(b"show run" + b"\n") #mostra la configurazione in esecuzione
    connessione.write(b"copy run start" + b"\n") # copia la configurazione in esecuzione in quella di avvio
    connessione.write(b"startup-config" + b"\n") # nome del file con la configurazione di avvio
    connessione.write(("copy startup-config tftp://" + servertftp + "\n").encode()) #copia la startup-config nel server TFTP, in modo da aggiornare il nomefile se l'ind_IPname è cambiato
    connessione.write(b"\n")
    connessione.write(b"\n")
    connessione.write(b"exit" + b"\n")     # FINE DELLA CONFIGURAZIONE; ESCI
    report = connessione.read_all().decode() #salva in report tutto quello che viene scambiato
    print("     REPORT DEI MESSAGGI SCAMBIATI \n")
    print (report)
    print("----------------- FINE DEL REPORT -------------------------------------------")
    #
 uscita = input("Vuoi uscire [s/n]: ")
 if uscita[0].lower() =="s" :  #considera solo il primo carattere digitato
    esci = "s"
    input("Premere Invio per terminare")
    exit()

