#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("*"*110 +"\n")
print("Programma in Python 3.x per l'analisi della configurazione di un PC\n")
#
import platform
import os
import subprocess
import csv
from sys import exit
import requests
import time
#--------------------------------------
def cercavendor(mac):  # funzione che determina il vendor della scheda con il mac indicato
    #il sito contenuto nell'URL è in grado di fornire un file in formato .csv che contiene il nome del costruttore della scheda di cui è noto l'ind. MAC
    url = "http://macvendors.co/api/" + mac + "/csv"   #nell'url chiedi che la risposta sia una stringa in formato .csv
    risposta = requests.get(url)                       #chiedi come risposta il costruttore della scheda di cui si fornisce il mac
    risposta = risposta.text   #metti in risposta il testo della risposta
    leggivendor = csv.reader(risposta, delimiter=",")  #usa il metodo .reader del modulo csv per trovare il costruttore
    n=0
    for riga in leggivendor:
        if n==0:
           vendor=riga[0]   # leggi solo la prima riga che è quella con il nome del costruttore
           n=n+1
    return  vendor     #la funzione restituisce la stringa che contiene il nome del costruttore 
#------------------
def comando_windows(comando):
    if sist_operativo == "Windows":
       out_comando = subprocess.check_output(comando)  # invia il comando al sistema operativo e salva la risposta 
       output_comando = out_comando.split() #crea una lista contenete tutte le singole parole dell'output espresse come byte
       k = 0 
       for parola in output_comando:
           parola = str(parola,"iso-8859-1")  # converte ogni parola da byte a stringa 
           output_comando[k] = parola
           k = k+1
       return output_comando
    else:
      print("Attenzione! Per ora il programma funziona solo per sistemi operativi Windows!")
      print("*"*110 + "\n")
      esci = input("Premere un tasto per uscire!")
      exit
      return
#--------------------------------------------------------------
def aprifile(nomefile,hostname):
    file = open(nomefile, "w")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.write("Programma in Python 3.x per l'analisi della configurazione di un PC\n")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.write(" Programma realizzato da Onelio Bertazioli \n")
    file.write("\n")
    file.write("*"*110 +"\n")
    file.write("\n")
    file.close()
    return nomefile
#------------------------------------------------------------------------
def cerca_config_ip(comando):  #chiede al s.o. gli ind. mac delle schede, individua la scheda attiva, cerca in ipconfig /all la config IP della scheda attiva
    output = []
    k = 0
    m=0
    for parola in comando:  # togli tutte le parole uguali a "." e ":"
        if parola != "." and parola != ":":
           output.insert(m,comando[k])
           output[m] = output[m].strip(".")  #togli anche l'eventuale "." finale della parola
           m = m+1
        k = k+1
    #cerca la scheda attiva
    k=0
    for cercahost in output:  # cerca l'hostname
        if cercahost == "host":
            hostname=output[k+1]
            break
        k=k+1
    nomefile="Report_pc_" + hostname + "_host_in_rete_data_" + str(data) + "_ora_" + str(oranome) + "_.txt"
    aprifile(nomefile,hostname)
    print(nomefile)
    #cerca la scheda attiva
    out = subprocess.check_output("getmac /FO csv /V ") #chiedi gli indirizzi MAC delle schede di rete con l'ouput in formato .csv
    out=out.decode()
    with open("out.csv","w", newline='') as file:  # scrivi gli ind. mac in un file .csv
        file.write(out)
    with open("out.csv","r") as filecsv:
      leggifile = csv.reader(filecsv, delimiter=",")
      continua ="no"
      for riga in leggifile: #verifica che ci sia almeno una scheda attiva
          if riga[0] == "Nome connessione":
                pass    #è la prima riga non fare niente
          else:
                riga[3] != "Supporto disconnesso"
                continua="si"
    #------------------------
    if continua =="si":
      with open("out.csv","r") as filecsv:  #apri il file, cerca gli indirizzi MAC delle schede, cerca la scheda attiva e la sua config. IP
        leggifile = csv.reader(filecsv, delimiter=",")
        for riga in leggifile:
            if riga[0] == "Nome connessione":
                pass    #è la prima riga non fare niente  
            else:
                file = open(nomefile, "a")
                tipo_scheda=riga[0]
                #
                mac=riga[2]# in notazione windows
                #
                mac_scheda=riga[2].replace("-",":")# cambia separatore per ricerca vendor
                vendor=cercavendor(mac_scheda)
                print("*"*110)
                print("Scheda ",tipo_scheda," ; ind. MAC: ",mac_scheda, " ; vendor: ", vendor)
                file.write("*"*110 + "\n")
                file.write("Scheda " + tipo_scheda + " ; ind. MAC: "+ mac_scheda + " ; vendor: " + vendor + "\n")
                attiva="si"
                if riga[3]=="Supporto disconnesso":
                    attiva="no"
                print("Scheda attiva: ", attiva)
                file.write("Scheda attiva: " + attiva + "\n")
                file.write("*"*110 + "\n")
                #
                k=0
                if attiva =="si":#cerca l'indirizzo IP della scheda attiva
                    fineciclo="no"
                    for parola in output:
                        #if output[k] == "NetBIOS":
                         #           break   #quando iniziano i parametri della scheda successiva interrompi
                        #   
                        if parola == mac:
                            for n in range(1,1000):
                                if output[k+n] == "IPv4":
                                    ind_IP=output[k+n+1].strip("(Preferenziale)")
                                    #
                                    mask=output[k+n+4]
                                elif output[k+n] == "predefinito":
                                    gateway=output[k+n+1]
                                elif output[k+n] == "DNS":
                                    dns=output[k+n+1]
                                    fineciclo="si"
                                    break
                                    #
                        if fineciclo=="si":
                            break
                        k = k+1 #continua la ricerca dei parametri IP
                    file.close()        
                    configip=[] #metti la configurazione IP in una lista
                    configip.insert(0,hostname)
                    configip.insert(1,mac_scheda)#aggiungi anche l'ind. MAC della scheda
                    configip.insert(2,ind_IP)
                    configip.insert(3,mask)
                    configip.insert(4,gateway)
                    configip.insert(5,dns)
      os.remove("out.csv")# elimina il file creato              
    else:
      print("tutti i supporti sono disconnessi!")
      file = open(nomefile, "a")
      file.write("*"*110 + "\n")
      file.write("\n")
      file.write("Attenzione! Tutte le schede di rete sono disconnesse!! \n")
      file.write("\n")
      file.write("*"*110 + "\n")
      file.write("\n")
      file.write("*"*110 + "\n")
      file.close()
      exit()
    #
    return configip,nomefile #restituisce una lista con config IP e nome del file
#---------------------------------------------------
def stampaconfig(conf_ip,nomefile):
    print("*"*110 + "\n")
    print("Configurazione del PC attiva: \n")
    print("Nome host           => " + conf_ip[0] + "\n")
    print("Ind. MAC scheda     => " + conf_ip[1] + "\n")
    print("Indirizzo IP        => " + conf_ip[2] + "\n")
    print("Subnet mask         => " + conf_ip[3] + "\n")
    print("Gateway predefinito => " + conf_ip[4] + "\n")
    print("Server DNS          => " + conf_ip[5] + "\n")
    
    print("*"*110 + "\n")
    file = open(nomefile, "a")
    file.write("*"*110 + "\n")
    file.write("Configurazione del PC attiva: \n")
    file.write("Nome host               => " + conf_ip[1] + "\n")
    file.write("Ind. MAC scheda     => " + conf_ip[0] + "\n")
    file.write("Indirizzo IP              => " + conf_ip[2] + "\n")
    file.write("Subnet mask           => " + conf_ip[3] + "\n")
    file.write("Gateway predefinito => " + conf_ip[4] + "\n")
    file.write("Server DNS             => " + conf_ip[5] + "\n")
    
    file.write("*"*110 + "\n")
    file.close()
#- PROGRAMMA PRINCIPALE ----------------------------------------------------------------------
orario = time.strftime("%H:%M")
oranome = time.strftime("%H_%M")
data = time.strftime("%d-%m-%Y")
print("*"*110 + "\n")
print ("Data: " + str(data) + "; Ora: " + str(orario) + "\n")
#------------------------
sist_operativo = platform.system()
out_comando=comando_windows("ipconfig /all") #output di ipconfig /all
output_comando=cerca_config_ip(out_comando)   #cerca la configurazione IP: hostname, ind IP, subnet mask, gateway, DNS
config_ip=output_comando[0]
nomefile=output_comando[1]
stampaconfig(config_ip,nomefile)# stampa la config IP
exit() 


