#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("Programma in Python 3.x per l'invio di comandi via SSH a un dispositivo LINUX, salvando le risposte in un file")
print("e ne fa il backup su un server TFTP,")
print("leggendo indirizzi IP, username e password da un file.")
print("Il file deve avere il formato .csv (va usato come separatore uno spazio):")
print("la prima riga deve contenere l'indirizzo IP del server TFTP")
print("le altre righe del file contengono <Indirizzo IP> <username> <password> di ciascun dispositivo \n")
print("ESEMPIO DI FILE: \n")
print("10.0.0.150")
print("10.0.0.223 studente telecom")
print("10.0.0.68 userpippo passwordpippo")
print("---------------------------------------------------------------------------------------------------")
print("Realizzato da Onelio Bertazioli")
print("---------------------------------------------------------------------------------------------------")
#
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
from netmiko import ConnectHandler # modulo che gestisce la connessione via SSH 
import platform
import subprocess
import time
import csv
from sys import exit
sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
#funzione che esegue un ping sull'indirizzo IP passato come parametro
def ping(indip):
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping " + indip + " -n 4 -w 200").returncode  # fai due richieste di echo (la prima può fallire) con timeout di 500 ms
    else:
       pinga = subprocess.run(("ping " + indip + " -c 4 -w 200"),shell=True).returncode      # con LINUX funziona questo
    return pinga
#---------------------------------------------------------------------------------------------------
nomefile = "fileipuserpw.csv" #nome di default del file da aprire
print("---------------------------------------------------------------------------------------------------\n")
#determina data e ora da inserire nel report del nome del file
orario = time.strftime("%H:%M")
oranome = time.strftime("%H_%M") #cambia il separatore da : in _ per poterlo mettere nel nome del file di report
data = time.strftime("%d-%m-%Y")
print ("data: " + str(data) + "; ora: " + str(orario))
#--------------------------------------------------------------------------------------------------------
# apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
filebak = "report_backup_config_data_" + str(data) + "_ora_" + str(oranome) + "_.txt"
salvareport = open(filebak, "w")
salvareport.write("---------------------------------------------------------------------------------------------------\n")
salvareport.write(" Programma realizzato da Onelio Bertazioli " + "\n")
salvareport.write("---------------------------------------------------------------------------------------------------\n")
salvareport.write("Data: " + str(data) + " Ora: " + str(orario)) #scrivi nel file la data e l'ora del backup
salvareport.write("\n")
#---------------- lettura indirizzi IP, username e password fatti con il modulo csv ----------------------
with open("fileipuserpw.csv") as filecsv:
    leggifile = csv.reader(filecsv, delimiter=' ')
    n=0
    for riga in leggifile:
       if n==0:
         servertftp=riga[0]#indirizzo IP del server TFTP
         print ("Nome del file: " + nomefile)
         print ("Server TFTP: " + servertftp)
         esitoping = ping(servertftp)
         if esitoping == 0:                                 # SE IL PING HA SUCCESSO RESTITUISCE 0
            #print ("--------------------------------------------------------------------------------------------------- \n")
            print ("Il server TFTP " + servertftp + " è funzionante!")
            #print ("--------------------------------------------------------------------------------------------------- \n")
            salvareport.write("\n")
            salvareport.write("Il server TFTP " + servertftp + " è funzionante!")
            salvareport.write("\n")
            tftp="si"
            n=n+1
         else:
            #print ("---------------------------------------------------------------------------------------------------\n")
            print ("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE!\n")
            print ("IMPOSSIBILE EFFETTUARE IL BACKUP! IL PROGRAMMA VIENE TERMINATO!\n")
            #print ("---------------------------------------------------------------------------------------------------\n")
            salvareport.write("-----------------------------------------------------------------------")
            salvareport.write("\n")
            salvareport.write("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE! \n")
            salvareport.write("IMPOSSIBILE EFFETTUARE IL BACKUP! IL PROGRAMMA VIENE TERMINATO!")
            salvareport.write("\n")
            salvareport.write("-----------------------------------------------------------------------\n")
            input("Premere un tasto per uscire!")
            exit()
       else:
            HOST=riga[n-1]
            user=riga[n]
            password=riga[n+1]
            print("---------------------------------------------------------------------------------------------------\n")
       #salva nel report
            salvareport.write("\n")
            salvareport.write("Nome del file: " + nomefile)
            salvareport.write("\n")
            salvareport.write("Server TFTP: " + servertftp)
            salvareport.write("\n")
            salvareport.write("---------------------------------------------------------------------------------------------------\n")
  # VERIFICA CON UN PING CHE l'HOST SIA RAGGIUNGIBILE
            esitoping = ping(HOST)
            if esitoping == 0:                                # l'host ha risposto al ping
                print ("---------------------------------------------------------------------------------------------------")
                print ("Il dispositivo (host) " + HOST + " risponde! Attendere!")
                #
                salvareport.write("\n")
                salvareport.write("--------------------------------------------------------------------------\n")
                salvareport.write("       Il dispositivo (host) " + HOST + " risponde!               \n ")
                salvareport.write("--------------------------------------------------------------------------\n")
                salvareport.write("\n")
        #  apri una connessione SSH con l'host, inviagli i comandi e salva le risposte
                print("----------------------------------------------------\n")
                print("Connessione SSH al dispositivo (host): " + HOST)
                #print("----------------------------------------------------\n")
                connessione_SSH = ConnectHandler(device_type='linux', ip = HOST, username = user, password = password)  #apre la connessione SSH
        # invia i comandi
                hostname=connessione_SSH.send_command_timing("hostname",5)  #richiesta dell'hostname
                print("hostname del dispositivo: " + hostname)
                comando =  "ip address" + "\n"  #  "\n" corrisponde a <invio>
                print("Comando inviato: " + comando)
                salvareport.write("\n")
                salvareport.write("hostname del dispositivo: " + hostname)
                salvareport.write("\n")
                salvareport.write("Comando inviato: " + comando)
                salvareport.write("\n")
        #    
                risposta = connessione_SSH.send_command_timing(comando,5) #invia il comando e accetta il nome proposto con timeout 2 (default 1)
                print ("---------------------------------------------------------------------------------------------------")
                print ("Risposta ricevuta dal dispositivo " + hostname + "(" + HOST+ ")" + " ; file di report inviato al server TFTP: " + servertftp + " \n" )
                print (risposta)
                salvareport.write("--------------------------------------------------------------------------\n")
                salvareport.write("Risposta ricevuta dal dispositivo " + hostname  + "(" + HOST+ ")"  + " ; file di report inviato al server TFTP: " + servertftp + " \n" )
                salvareport.write("\n")
                salvareport.write(risposta + "\n")
                salvareport.write("\n")
                salvareport.write("-----------------------------------------------------------------------------------------\n")
                print ("--------------------------------------------------------------------------------------------------- \n")
        #
            else:   # se il ping fallisce viene restituito un numero >0
                print ("---------------------------------------------------------------------------------------------------")
                print ("ATTENZIONE! Il dispositivo (host) " + HOST + " non risponde! Potrebbe essere spento o non collegato in rete.")
                print ("---------------------------------------------------------------------------------------------------")
                salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
                salvareport.write("Il dispositivo (host) " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
                salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
#
if tftp != "no":
    print ("Salvo il report sul server TFTP " + servertftp)
    salvareport.close() #chiudi il file del report
    salvatftp = subprocess.run("tftp " + servertftp +" put " + filebak).returncode   #invia il file di report al server TFTP
else:
    salvareport.close() #chiudi il file del report
print ("\n Grazie per aver usato il programma!\n")
exit()
#input("Premere Invio per uscire.")

