#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("\nProgramma in Python 3.x per l'invio di comandi via TELNET a un dispositivo LINUX, salvando le risposte in un file")
print("con backup su un server TFTP.")
print("Legge indirizzi IP, username e password dal file <fileipuserpw.csv>.")
print("Il file deve avere il formato .csv (va usato come separatore uno spazio):")
print("la prima riga deve contenere l'indirizzo IP del server TFTP")
print("le altre righe del file contengono <Indirizzo IP> <username> <password> di ciascun dispositivo \n")
print("ESEMPIO DI FILE: \n")
print("10.0.0.150")
print("10.0.0.223 studente telecom")
print("10.0.0.68 userpippo passwordpippo")
print("---------------------------------------------------------------------------------------------------")
print(" Realizzato da Onelio Bertazioli")
print("---------------------------------------------------------------------------------------------------")
#
#--------------------- MODULI DA IMPORTARE -----------------------------------------------------
import csv
import platform
import subprocess
import time
import telnetlib  #gestisce la connessione via Telnet
from sys import exit
#--------------------------------------------------------------------------------------------------------
sist_operativo = platform.system() #determina la piattaforme del sistema operativo: Windows o linux
#
def ping(indip):                    #funzione che esegue un ping sull'indirizzo IP passato come parametro
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping -n 3 -w 200 " + indip).returncode  # fai due richieste di echo (la prima può fallire) con timeout di 500 ms
    else:
       pinga = subprocess.run(("ping " + indip + " -c 4 -w 300"), shell=True).returncode      # con LINUX funziona questo
    return pinga
#---------------------------------------------------------------------------------------------------
nomefile = "fileipuserpw.csv" #nome di default del file da aprire
#print("---------------------------------------------------------------------------------------------------\n")
#determina data e ora da inserire nel report del nome del file
ora = time.strftime("%H_%M")
data = time.strftime("%d-%m-%Y")
print ("data: " + str(data) + "; ora: " + str(ora))
#--------------------------------------------------------------------------------------------------------
# apri in scrittura un file di testo per il report dei messaggi contenete data e ora della sua creazione
filebak = "report_backup_config_data_" + str(data) + "_ora_" + str(ora) + "_.txt"   #NOME DEL FILE DI REPORT CHE VIENE SALVATO IN LOCALE E SUL SERVER TFTP
salvareport = open(filebak, "w")  # APRE IL FILE IN SCRITTURA
salvareport.write("---------------------------------------------------------------------------------------------------\n")
salvareport.write(" Programma realizzato da Onelio Bertazioli " + "\n")
salvareport.write("---------------------------------------------------------------------------------------------------\n")
salvareport.write("Data: " + str(data) + " Ora: " + str(ora)) #scrivi nel file la data e l'ora del backup
salvareport.write("\n")
#---------------- lettura indirizzi IP, username e password fatti con il modulo csv ----------------------
tftp ="si"
with open("fileipuserpw.csv") as filecsv:
    leggifile = csv.reader(filecsv, delimiter=' ')
    n=0
    for riga in leggifile:
     if n==0:
       servertftp=riga[0]#indirizzo IP del server TFTP
       print ("Nome del file: " + nomefile)
       print ("Server TFTP: " + servertftp)
       esitoping = ping(servertftp)
       if esitoping == 0:                                 # SE IL PING HA SUCCESSO RESTITUISCE 0
            #print ("--------------------------------------------------------------------------------------------------- \n")
            print ("Il server TFTP " + servertftp + " è funzionante!")
            #print ("--------------------------------------------------------------------------------------------------- \n")
            salvareport.write("Il server TFTP " + servertftp + " è funzionante! \n")
            n=n+1
       else:
            print ("---------------------------------------------------------------------------------------------------\n")
            print ("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE!\n")
            print ("IMPOSSIBILE EFFETTUARE IL BACKUP! IL PROGRAMMA VIENE TERMINATO!\n")
            print ("---------------------------------------------------------------------------------------------------\n")
            salvareport.write("-----------------------------------------------------------------------\n")
            salvareport.write("ATTENZIONE: IL SERVER TFTP " + servertftp + " NON E' RAGGIUNGIBILE! \n")
            salvareport.write("IMPOSSIBILE EFFETTUARE IL BACKUP! IL PROGRAMMA VIENE TERMINATO! \n")
            salvareport.write("-----------------------------------------------------------------------\n")
            input("Premere un tasto per uscire!")
            exit()
        #finisce
     else:
            HOST=riga[n-1]
            user=riga[n]
            password=riga[n+1]
            #print(HOST,user,password)  # decommentare se si vuole fare una verifica
            print("---------------------------------------------------------------------------------------------------")
           #salva nel report
            salvareport.write("Nome del file: " + nomefile + "\n")
            salvareport.write("Server TFTP: " + servertftp + "\n")
            salvareport.write("---------------------------------------------------------------------------------------------------\n")
 #
 # VERIFICA CON UN PING CHE l'HOST SIA RAGGIUNGIBILE
            esitoping = ping(HOST)
            if esitoping == 0:                                # l'host ha risposto al ping
                print ("--------------------------------------------------------------------------------------------------- \n")
                print ("Il dispositivo (host)  " + HOST + " risponde! Attendere! \n")
                #
                salvareport.write("--------------------------------------------------------------------------\n")
                salvareport.write("          Il dispositivo (host) " + HOST + " risponde!                \n")
                salvareport.write("--------------------------------------------------------------------------\n")
                print("Connessione Telnet al dispositivo (host): " + HOST)
         #  apri una connessione TELNET con l'host, inviagli i comandi e salva le risposte
                connessione = telnetlib.Telnet(HOST)          # apre la connessione telnet
                connessione.read_until(("login: ").encode())  #aspetta di ricevere la richiesta di username
                connessione.write((user + "\n").encode())        #trasmetti lo username + <invio> (con "\n")    
                connessione.read_until(("Password: ").encode())
                connessione.write((password + "\n").encode())
                salvareport.write("Invio i comandi al dispositivo \n")
                comando1 = "hostname"                          #richiesta dell'hostname
                connessione.write((comando1 + "\n").encode())  #invio comando1
                comando2 = "ip address"                        # comando per la verifica della configurazione IP
                connessione.write((comando2 + "\n").encode())  #invio comando2
                connessione.write(("exit" + "\n").encode())
                report = connessione.read_all().decode()      #salva in report tutto quello che viene scambiato
                # manda a video e salva sul file
                print("Comandi inviati: " + comando1 + " ; " + comando2)
                salvareport.write("Comandi inviati: " + comando1 + " ; " + comando2 + "\n")
                print ("Messaggi scambiati con il dispositivo " + HOST + " ; file di report inviato al server TFTP: " + servertftp)
                print (report)
                salvareport.write("--------------------------------------------------------------------------\n")
                salvareport.write("Messaggi scambiati con il dispositivo " + HOST + " file di report inviato al server TFTP: " + servertftp + " \n")
                salvareport.write(report + "\n")
                #
            else:   # se il ping fallisce viene restituito un numero >0
                print ("---------------------------------------------------------------------------------------------------")
                print ("Il dispositivo (host) " + HOST + " non risponde, potrebbe essere spento o non collegato in rete")
                print ("---------------------------------------------------------------------------------------------------\n")
                salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
                salvareport.write("Il dispositivo (host) " + HOST + " non risponde, potrebbe essere spento o non collegato in rete  \n")
                salvareport.write("--------------------------------------------------------------------------------------------------------------\n")
if tftp != "no":
    print("Trasferisco il file di report al server TFTP " + servertftp + "\n")
    salvareport.write("Trasferisco il file di report al server TFTP " + servertftp) 
    salvareport.close() #chiudi il file del report
    
    salvatftp = subprocess.run("tftp " + servertftp +" put " + filebak).returncode
else:
    salvareport.close() #chiudi il file del report
print ("Grazie per aver usato il programma!")
#fine=input("\nPremere Invio per uscire")
exit()

