print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#------------------------------------------------------------------------------------------------------
print("\n")
print("*"*110 +"\n")
print("Programma in Python 3.x per l'analisi della configurazione IP di un PC, l'individuazione degli host attivi \n")
print("sulla stessa rete IPv4 del PC e dei vendor delle loro schede di rete \n")
print("*"*110 +"\n")
print(" Realizzato da Onelio Bertazioli \n")
# ------------------ Moduli da importare
from sys import exit
import csv
import platform
import subprocess
import time
import ipaddress   # serve per determinare indirizzi IP di rete, di tutti gli host della rete IP, di broadcast ecc.
import requests    # serve per cercare su un sito i nomi dei costruttori delle schede di cui si ha l'indirizzo MAC
#---------------------------------------------------------
def cercavendor(mac):  # funzione che determina il vendor della scheda con il mac indicato
    #il sito contenuto nell'URL è in grado di fornire un file in formato .csv che contiene il nome del costruttore della scheda di cui è noto l'ind. MAC
    url = "http://macvendors.co/api/" + mac + "/csv"   #nell'url chiedi che la risposta sia una stringa in formato .csv
    risposta = requests.get(url)                       #chiedi come risposta il costruttore della scheda di cui si fornisce il mac
    risposta = risposta.text   #metti in risposta il testo della risposta
    leggivendor = csv.reader(risposta, delimiter=",")  #usa il metodo .reader del modulo csv per trovare il costruttore
    n=0
    for riga in leggivendor:
        if n==0:
           vendor=riga[0]   # leggi solo la prima riga che è quella con il nome del costruttore
           n=n+1
    return  vendor     #la funzione restituisce la stringa che contiene il nome del costruttore 
#-------------------------------------------------------
def convertimac(indmac):  #converte l'ind mac nel formato aa:bb:cc: ecc.
    ind_mac=indmac.replace("-",":")
    return ind_mac
#---------------------------------------------------------------------------------------------------------------------------
def converti(numero):   #converti una cifra da decimale a binario e restituisci la stringa di 8 uni e zeri corrispondente 
    cifrabin = bin(numero)  #converte una cifra decimale in binario espressa come 0b11110000
    maskbin = str(cifrabin[2:])# togli lo 0b che precede la cifra in binario
    lung = len(maskbin)
    if lung == 8:         # se la cifra 
       return maskbin
    elif lung <<8:
         maskbina = maskbin + "0"*(8-lung)
         return maskbina
#----------------------------------------------------------------------------
def converti_ip(numero):   #converti una cifra da decimale a binario e restituisci la stringa di 8 uni e zeri corrispondente 
    cifrabin = bin(numero)  #converte una cifra decimale in binario espressa come 0b11110000
    ipbin = str(cifrabin[2:])# togli lo 0b che precede la cifra in binario
    lung = len(ipbin)
    if lung == 8:          
       return ipbin
    elif lung <<8:
         ipbina = "0"*(8-lung) + ipbin
         return ipbina
#---------------------------------------------------------------------------------------------------------------------------
def contauno(cifra): #conta il numero di 1 in una cifra decimale passata come stringa espressa in binario con 8 bit
    binario = converti(int(cifra)) # richiama la funzione che converte in binario la cifra 
    bina = str(binario)  #esprimi la cifra binaria come stringa 
    if cifra != "0":       #elimina tutti gli zeri presenti nella cifra se c'è almeno un 1
       for n in range(0,8):
           if bina[-1] == "0":
              bina = bina.strip("0")
           numuni = len(bina)
       return numuni
    elif cifra == "0":  # se la cifra decimale è 0 (espressa come stringa) restituissci 0 come numeri di 1
         numuni = 0
         return numuni
#-----------------------------------------------------------------------------------------------------
#funzione che esegue un ping sull'indirizzo IP passato come parametro
def ping(indip):
    #print(".")
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping " + indip + " -n 2 -w 200").returncode  # fai 2 richieste di echo (la prima può fallire) con timeout di 200 ms
    else:
       pinga = subprocess.run("ping " + indip + " -n 2 -w 200", shell=True).returncode      # con LINUX funziona questo
    return pinga
#---------------------------------------------------------------------
def comando_windows(comando):
    if sist_operativo == "Windows":
       out = subprocess.check_output(comando)  # invia il comando al sistema operativo e salva la risposta 
       output_comando = out.split() #crea una lista contenete tutte le singole parole dell'output espresse come byte
       k = 0 
       for parola in output_comando:
           parola = str(parola,"iso-8859-1")  # converte ogni parola da byte a stringa 
           output_comando[k] = parola
           k = k+1
       return output_comando
    else:
      print("Attenzione! Per ora il programma funziona solo per sistemi operativi Windows!")
      print("*"*110 + "\n")
      esci = input("Premere un tasto per uscire!")
      exit
      return 
#----------------------------------------------------
orario = time.strftime("%H:%M")
oranome = time.strftime("%H_%M")
data = time.strftime("%d-%m-%Y")
print("*"*110 + "\n")
print ("Data: " + str(data) + "; Ora: " + str(orario) + "\n")
#--------------------------------------------------------------------------------------------------------------------
sist_operativo = platform.system() #determina la piattaforma del sistema operativo: Windows o linux
#--------------------------------------------------------------------------------------------------------------------
out = comando_windows("ipconfig /all") # analisi dell'output di ipconfig /all
output = []
k = 0
m=0
for parola in out:  # togli tutte le parole uguali a "." e ":"
    if parola != "." and parola != ":":
       output.insert(m,out[k])
       output[m] = output[m].strip(".")  #togli anche l'eventuale "." finale della parola
       m = m+1
    k = k+1
#--------------------------------------------------------------
print("*"*110 + "\n")
print("Configurazione del PC: \n")
#----------------------------------------------------------
wifi = "no" #parti assumendo che non ci siano schede di rete abilitate
eth = "no"
#--------------------------------------------
n = 0
for riga in output: #
    if output[n] == "host":
        hostname = output[n+1] # metti in hostname il nome host
        print("Nome host                => " + hostname + "\n")
#--------------------------------------------------------- apri un file e scrivici l'intestazione
        file = open("Report_pc_" + hostname + "_host_in_rete_data_" + str(data) + "_ora_" + str(oranome) + "_.txt", "w")
        file.write("\n")
        file.write("*"*110 +"\n")
        file.write("\n")
        file.write("Programma in Python 3.x per l'analisi della configurazione di un PC e l'individuazione dei dispositivi attivi sulla stessa rete IPv4 del PC\n")
        file.write("\n")
        file.write("*"*110 +"\n")
        file.write("\n")
        file.write(" Programma realizzato da Onelio Bertazioli \n")
        file.write("\n")
        file.write("*"*110 +"\n")
        file.write("\n")
        file.write("Data: " + str(data) + "; Ora: " + str(orario) + "\n")
        file.write("\n")
        file.write("*"*110 + "\n")
        file.write("\n")
        file.write("Configurazione del PC: \n")
        file.write("\n")
        file.write("Nome host                => " + hostname + "\n")
        file.write("\n")
#------------------------------------------------------- cerca nell'output le parole che identificano le diverse schede e i loro indirizzi
    elif output[n] == "Ethernet":
        tiposcheda = "Ethernet"
        if output[n+2] == "Stato":  #verifica se la scheda è disconnessa
            disconnessa = "si"
        else:
            disconnessa = "no"
            eth = "si"         # se non è disconnessa va trovato anche l'IP
#----------------------------------------------------------------------------------------#
    elif output[n] == "wireless" and output[n+1] == "Wi-Fi:":  # se è una scheda wi-fi
            tiposcheda = "Wi-Fi"
            if output[n+2] == "Stato":
                disconnessa = "si"
            else:
                disconnessa = "no"
                wifi = "si"       # se non è disconnessa va trovato anche l'IP
#----------------------------------------------------------------------------------------#
    elif output[n] == "wireless" and output[n+1] != "Wi-Fi:" or output[n] == "Teredo" or output[n] == "Tunnel":  #se ci sono altre connessioni wireless saltale
                tiposcheda = ""
#----------------------------------------------------------------------------------------#
    elif output[n] == "fisico" and tiposcheda == "Ethernet":
               ind_mac = output[n+1] # metti in ind_mac l'indirizzo MAC
               maceth = convertimac(ind_mac)                            # converti nella forma aa:bb:cc ecc.
               print("Ind. MAC scheda Ethernet => " + maceth + " (Disconnessa: " + disconnessa + ")\n")
               file.write("Ind. MAC scheda Ethernet => " + maceth + " (Disconnessa: " + disconnessa + ")\n")
               file.write("\n")
               if disconnessa == "no":
                   scheda = tiposcheda
                   indmac = maceth
    elif output[n] == "fisico" and tiposcheda == "Wi-Fi":
               ind_mac = output[n+1] # metti in ind_mac l'indirizzo MAC
               macwifi = convertimac(ind_mac)
               print("Ind. MAC scheda Wi-Fi    => " + macwifi + " (Disconnessa: " + disconnessa + ")\n")
               file.write("Ind. MAC scheda Wi-Fi    => " + macwifi + " (Disconnessa: " + disconnessa + ")\n")
               file.write("\n")
               if disconnessa == "no":
                   scheda = tiposcheda
                   indmac = macwifi
    elif output[n] == "IPv4":
               indirizzo_ip = output[n+1].strip("(Preferenziale)") # metti in indirizzo_ip l'indirizzo IP togliendo il (Preferenziale)
               print("Ind. IP scheda " + scheda + "  => " + indirizzo_ip + "\n")
               file.write("Ind. IP scheda " + scheda + "    => " + indirizzo_ip + "\n")
               file.write("\n")
           #
    elif output[n] == "mask":
               mask = output[n+1] # metti in mask la subnet mask                    
               #mask = "255.255.255.248" # test
               print("Subnet mask              => " + mask + "\n")
               file.write("Subnet mask              => " + mask + "\n")
               file.write("\n")
           #    
    elif output[n] == "predefinito":   #cerca l'ip del gateway predefinito
               gateway1 = output[n+1] #metti in gateway1 ciò che segue
               #print("GW1 " + gateway1)
               if gateway1 != "::":  # se gateway1 non è "::" hai trovato l'ip del gateway
                  gateway = gateway1
                  print("Gateway predefinito      => " + gateway + "\n")
                  file.write("Gateway predefinito      => " + gateway + "\n")
                  file.write("\n")
           #
    elif output[n] == "Server" and output[n+1] == "DNS": #se la parola che segue Server è DNS cerca l'ip del primo server DNS
               dns = output[n+2] # metti in dns l'ip del server DNS
               print("Server DNS               => " + dns + "\n")
               file.write("Server DNS               => " + dns + "\n")
               file.write("\n")
#------------------------------------------------
    if n+2 == len(output): # verifica che l'indice sia inferiore alla lunghezza della lista
              break
    n = n+1
#-------------------------------------------
if eth == "no" and wifi == "no":
    print("*"*110 + "\n")
    print("Attenzione! Tutte le schede di rete sono disconnesse!! \n")
    print("*"*110 + "\n")
# -------------- salva anche in un file ----------------
file.write("\n")
if eth == "no" and wifi == "no":
    file.write("*"*110 + "\n")
    file.write("\n")
    file.write("Attenzione! Tutte le schede di rete sono disconnesse!! \n")
    file.write("\n")
    file.write("*"*110 + "\n")
    file.write("\n")
    file.write("*"*110 + "\n")
#
#********************************************** INIZIO PROGRAMMA CHE DETERMINA L'INDIRIZZO DI RETE E FA I PING *******************************
#
print ("============ Analisi dell'indirizzo IPv4 e determinazione dell'indirizzo IPv4 di rete ===================\n")
print("Indirizzo IPv4 dell'host: " + indirizzo_ip + "\n")
file.write("*"*110 + "\n")
file.write("\n")
file.write("Indirizzo IPv4 dell'host: " + indirizzo_ip + "\n")
file.write("-"*110 +"\n")
file.write("\n")
#
print("Subnet mask: " + mask + "\n")
print("-"*110 +"\n")
file.write("Subnet mask: " + mask + "\n")
file.write("-"*110 +"\n")
file.write("\n")
#
#********************************************************************************************************************
cifre_mask = mask.replace(".", " ")  #sostituisci il punto con uno spazio in modo da poter creare una lista con il metodo split()
cifre_mask = cifre_mask.split()   #crea una lista che contiene le singole cifre decimali della subnet mask
#
primacifra = cifre_mask[0] # salta il punto che separa le cifre della subnet mask
secondacifra = cifre_mask[1]   #= int(mask[4:7])   # valore in decimale della seconda cifra
terzacifra = cifre_mask[2] #int(mask[8:11])  # valore in decimale della terza cifra
quartacifra = cifre_mask[3] #int(mask[12:16])  # valore in decimale della quarta cifra
#************************************************************************************************************************
#================================> conta gli 1 che ci sono in ciascuna cifra espressa come stringa e in binario
cifra1 = contauno(str(primacifra))   
cifra2 = contauno(str(secondacifra))
cifra3 = contauno(str(terzacifra))
cifra4 = contauno(str(quartacifra))
#================================>
#
lung_mask = int(cifra1) + int(cifra2)+ int(cifra3)+ int(cifra4) # numero totale di 1 presenti nella subnet mask
#
#================================>conversione in binario della subnet mask
c1 = converti(int(primacifra))    
c2 = converti(int(secondacifra))
c3 = converti(int(terzacifra))
c4 = converti(int(quartacifra))
#
maskbin = str(c1) + str(c2) + str(c3) + str(c4)  #subnet mask espressa in binario
#
#======================================================================================================================>
ind_ip = indirizzo_ip.replace(".", " ") #sostituisci il punto con uno spazio in modo da poter creare una lista
#
ind_ip= ind_ip.split() #crea una lista con le singole cifre dell'indirizzo IP
#------------------------------------------------------------------------------------------------------------------------
stripbin =[]  # inizializza una lista vuota
k=0
for cifra in ind_ip:
    stripbin[k:k] = [converti_ip(int(cifra))] #crea una lista che contiene le cifre dell'indirizzo IP espresse in binario
    k = k+1
#
ip_bin = ""  # inizializza una stringa in cui si metterà l'indirizzo IP espresso in binario
ip_bin = ip_bin.join(stripbin)  #crea una stringa riunendo tuttii campi della lista che contiene le singole cifre dell'IP
#
ind_rete = ip_bin[0:lung_mask] + "0"*(32-lung_mask) #prendi dall'indirizzp IPv4 un numero di bit pari alla lunghezza della subnet mask
#                                                   e falli seguire da tutti 0
cifra1_bin = ind_rete[0:8] #prendi i primi 8 bit e convertili in decimale
cifra1 = int(cifra1_bin, 2)
#
cifra2_bin = ind_rete[8:16] #prendi altri 8 bit e convertili in decimale
cifra2 = int(cifra2_bin, 2)
#
cifra3_bin = ind_rete[16:24] #prendi altri 8 bit e convertili in decimale
cifra3 = int(cifra3_bin, 2)
#
cifra4_bin = ind_rete[24:32] #prendi altri 8 bit e convertili in decimale
cifra4 = int(cifra4_bin, 2)
#
ind_rete_dec = str(cifra1) + "." + str(cifra2) + "." + str(cifra3) + "." + str(cifra4)     # metti insieme le cifre e aggiungi il punto di separazione
#------------------------------------------------------------------------------------------------------------------------------
print("Lunghezza della subnet mask: /" + str(lung_mask) + "\n")
file.write("Lunghezza della subnet mask: /" + str(lung_mask) + "\n")
file.write("\n")
print("Subnet mask espressa in binario:" + " "*4 + maskbin + "\n")
#
file.write("Subnet mask espressa in binario:" + " "*4 + maskbin + "\n")
file.write("-"*110 +"\n")
file.write("\n")
#
print("-"*110 +"\n")
print("Indirizzo IPv4 in binario" + " "*11 +ip_bin + "\n")
#
print("-"*110 +"\n")
file.write("Indirizzo IPv4 in binario" + " "*11 +ip_bin + "\n")
file.write("-"*110 +"\n")
#
print("Indirizzo IPv4 di rete in binario:" + " "*2 + ind_rete + "\n")
#
print("*"*110 +"\n")
file.write("-"*110 +"\n")
file.write("Indirizzo IPv4 di rete in binario:" + " "*2 + ind_rete + "\n")
file.write("\n")
#
ind_rete_cidr = ind_rete_dec + "/" + str(lung_mask)
print("Indirizzo IPv4 di rete in notazione CIDR: " + ind_rete_cidr + "\n")
print("-"*110 +"\n")
file.write("Indirizzo IPv4 di rete in notazione CIDR: " + ind_rete_cidr + "\n")
file.write("-"*110 +"\n")
#-------------------------------------------------------------------------------------------------------------------------------
# usa il modulo ipaddress per determinare indirizzi ip degli host, broadcast, ecc.
rete = ipaddress.ip_network(ind_rete_cidr)
#----------------------------------------------------------------------------------------------------------
max_num_host= rete.num_addresses-2  #calcola il numero massimo di indirizzi IPv4 utilizzabili per gli host
ind_broadcast = rete[-1]  #indirizzo IP di broadcast
inverse_mask = rete.hostmask
#----------------------------------------------------------------------------------------------------------
print("Inverse mask (o wildcard mask o host mask): " + str(inverse_mask) + "\n")
print("Numero totale di indirizzi IPv4 disponibili per gli host: " + str(max_num_host) + "\n")
print("Indirizzo IPv4 di broadcast: " + str(ind_broadcast) + "\n")
#
file.write("-"*110 +"\n")
file.write("\n")
file.write("Inverse mask (o wildcard mask o host mask): " + str(inverse_mask) + "\n")
file.write("Numero totale di indirizzi IPv4 disponibili per gli host: " + str(max_num_host) + "\n")
file.write("Indirizzo IPv4 di broadcast: " + str(ind_broadcast) + "\n")
file.write("\n")
#------------------------------------------------------------------------------------------------------------
ip_attivi = [] #inizializza una lista vuota che contiene tutti gli IP degli host attivi
k = 0
print("-"*110 +"\n")
print("ATTENDERE! Sto pingando i dispositivi in rete \n")
for ind_host in rete.hosts(): #determina tutti gli indirizzi IPv4 a disposizione degli host
    if str(ind_host) != str(indirizzo_ip): #non pingare l'IP del pc che si usa
       esitoping = ping(str(ind_host))
       if esitoping == 0:
          ip_attivi[k:k] = [str(ind_host)]
          k = k+1
       else:
          pass # non fare niente e vai avanti

#======================================= manda il comando arp -a e analizza l'output per determinare gli indirizzi mac degli host attivi
comando_arp = comando_windows("arp -a")
output_arp = comando_arp[9:] # salta le prime 9 parole
print("*"*110 +"\n")
print(" Configurazione delle schede di rete degli host attivi: \n")
print("ATTENDERE! Sto cercando i vendor \n")
print("Indirizzi IPv4     Indirizzi MAC         Costruttore    \n")
file.write("*"*110 + "\n")
file.write(" Configurazione delle schede di rete degli host attivi: \n")
file.write("\n")
file.write("Indirizzi IPv4     Indirizzi MAC         Costruttore    \n")
file.write("\n")
#
for k in range(0, len(ip_attivi)):
  for n in range(k,len(output_arp)):
     if ip_attivi[k] == output_arp[n]:
         indmac = output_arp[n+1].replace("-", ":")
         vendor = cercavendor(indmac)
         print(" " + ip_attivi[k] + "        " + indmac + "    " + vendor + "\n")
         file.write(" " + ip_attivi[k] + "        " + indmac + "    " + vendor + "\n")
         file.write("\n")
         break
     else:
         pass
file.write("*"*110 + "\n")
file.close()
print("*"*50 + "  FINE   " + "*"*50 + "\n")
#stop = input("Premere Invio per uscire! ")
exit()
